// Function used to change the class of the being.
// To be used befor running the move action.
Being changeBeing(Being being) {
  int x,y,changed;
  
  if (being.changed == isdead){
      return new Dead(being);
  }
  if (being.changed == iszombie){
      return new Zombie(being, being.generation);
  }
  if (being.changed == isweakenedZombie){
      return new WeakenedZombie(being, being.generation);
  }
  if (being.changed == ismadZombie){
      return new MadZombie(being, being.generation);
  }
  if (being.changed == issoldier){
      return new Soldier(being);
  }
  return being;
}

// Generic being class. Is not meant to be used
class Being { 
  int xpos, ypos, dir;
  int xdest,ydest;
  int attracted=0;
  int attractionStrength=0;
  int generation=0;  // generation of the zombie that infected the being
  int type, active; // type : zombie, ... active : >0 panic
  int originalType; // What it was before being a that type. Mostly usefull for zombies, and dead
  int deathCause=deathAlive; // will be used to store the origin of the death (will be passed on when changing object being to dead one
  int changed;
  int seeList[][] = {};
  int ignoreList[] = {};
  boolean update=false;  //true if needs to refresh the display when paused
  World wld;
  
  Being(){
  }
  
  Being(World _wld){
    wld=_wld;
  }

  // With planned structure (array of beings), can not die
  // should be killed by another object.
  void die(int _deathCause){
    deathCause=_deathCause;
    changed=isdead;
    setBeing(xpos,ypos,dead);
  }

  // Places a being at a random position on an empty area
  void position(){
    for (int ok=0; ok<100; ok++){
      xpos = wld.playArea.setX(); 
      ypos = wld.playArea.setY();//(int)random(playArea.gHeight);
      if (get(xpos,ypos)==empty) { ok = 100; }
    }
  }
  
  void setBeing(int x, int y,color colour) {
    
    for (int i=0;i<scale;i++){
      for (int j=0;j<scale;j++){
        set(x+i,y+j,colour);
      }
    }
    //set(x,y,colour);
  }
  
  int lookPixel(int seeList[][],int ignoreList[],int x, int y){
    color colour;
    
    colour = get(x,y);
    if (!wld.playArea.inside(x,y)) return seeWall; // would probably have to change that
    for (int j=0; j<seeList.length; j++){
      if (colour == seeList[j][0]) return seeList[j][1];
    }
    
    // Checks if sees anything that is not in ignoreList
    int k;
    for ( k=0; k<ignoreList.length;k++){
      if (colour == ignoreList[k]) break;
    }
    if (k==ignoreList.length) return seeSomething; 
    
    // saw nothing
    return seeNothing;
  }
  
  // look in a given direction, up to a certain distance
  // return result depending on first object seen
  // beings look at what is drawn on the screen
  int look(int seeList[][],int ignoreList[],int d,int dist){
    int x,y; 
    color colour;
        
    x = xpos;
    y = ypos;
    for(int i=0; i<dist; i++){
      x += directionX(d);
      y += directionY(d);
      colour = lookPixel(seeList, ignoreList,x,y);
      if (colour!=seeNothing) return colour;      
    }
    return seeNothing; // saw nothing
  }
  
  int directionX(int dir){
    switch(dir){
      case 1:
      case 3:
        return 0;
      case 2:
        return 1*scale;
      case 4:
        return -1*scale;
    }
    return 0;
  }
  
  int directionY(int dir){
    switch(dir){
      case 1:
        return -1*scale;
      case 2:
      case 4:
        return 0;
      case 3:
        return +1*scale;
    }
    return 0;
  }
  
  void attract(int x, int y, int tempAttracted, int tempStrength){
    //if (tempStrength>attractionStrength||attracted==0){
      xdest=x;
      ydest=y;
      attracted=tempAttracted;
      attractionStrength=tempStrength;
    //}
  }
  
  // If the being is being attracted, will turn toward 
  // or away from  the attractor
  void turnToTarget(){
    int dx = xpos-xdest;
    int dy = ypos-ydest;
    if (dx!=0 && dy!=0){
      if (abs(dx)>abs(dy) || (abs(dx)==abs(dy) && (int)random(1)==0)){
        if ((dx>0 && attracted > 0)||(dx<0 && attracted<0)) dir = 4;
        else dir =2;
      }
      else {
        if ((dy>0 && attracted > 0)||(dy<0 && attracted<0)) dir = 1;
        else dir = 3;
      }
    }
    if (attracted > 0) attracted --;
    else if (attracted <0) attracted ++;
  }

    // Turns the being into a zombie
  void infect(int _generation, int _type){
    changed = _type;
    generation = _generation;
  }
  
  void drawBeingColor(color colour){
    setBeing(xpos,ypos,colour);
  }
  // when drawing the being, out of the move() method. More options available
  void drawBeingOutside(){
    if (!gameSequence.freeze || world.displayBeingData.modeNormal()){
      drawBeing();
    }
    else world.displayBeingData.display(this);
  }
  void drawBeing(){}
  void move(){}
  void equip(){}
}

class Human extends Being {
  int belief, maxBelief;
  int rest;
  int seeList[][] = {  {panicHuman,seePanicHuman},
                       {zombie,seeZombie},
                       {activeZombie,seeZombie},
                       {weakenedZombie,seeZombie},
                       {activeWeakZombie,seeZombie}};
  int ignoreList[] = {empty,dead,hit};
  
  Human(){
  }
  
  Human(World _wld){
    super(_wld);
    dir = (int)random(4)+1;
    type = ishuman;
    originalType=ishuman;
    active = 0;
    belief=500;
    maxBelief=500;
    rest=40;
    changed=-1;
  }
  
  Human(Being being){
    xpos = being.xpos;
    ypos = being.ypos;
    dir = being.dir;
    type = ishuman;
    originalType=being.type;
    active = 0;
    belief = 500;
    maxBelief = 500;
    rest = 40;
    changed = -1;
    wld=being.wld;
  }
  
  void infect(int _generation, int _type){
    changed = _type;
    generation = _generation;
    
    if (_type==isweakenedZombie) wld.numInoculatedHumans++;
  }
  
  void equip(){
    changed = issoldier;
  }
  
  void drawBeing(){
    if (active > 0) setBeing(xpos, ypos, panicHuman);
    else setBeing(xpos, ypos, human);
    if (update) update=false;
  }
  
  void move(){
        
    int r = (int)random(3); //being move once every 4 ticks, except panic who run every
    if (active>0 || r==1){ // if panicHuman or just moves by one
      setBeing(xpos, ypos, empty);
      if(belief<=0){
        active=0;
        maxBelief-=100;
        belief=0;
        rest=0;
      }
      
      // if sees nothing in direction, moves   
      if (look(seeList,ignoreList,dir,1)==seeNothing) {
        xpos += directionX(dir);
        ypos += directionY(dir);
      }
      
      // otherwise turns
      else {
        dir = (int)random(4)+1; 
      }

      drawBeing();
      if (active>0) {active--;}
    }

    // everybody looks in direction
    int target = look(seeList,ignoreList,dir,10);

    // Saw a zombie !! Believes in them, and turns around
    if (target==1){
      maxBelief=500;
      belief=500;
      active=10;
      rest=0;
      dir = dir + 2; 
      if (dir>4) dir = dir - 4; 
    }
    
    // Saw someone panicking !!
    else if(target==seePanicHuman){ 
      active=10;
      if(belief>0){
        belief--;
      }
      else if(belief==0 && maxBelief!=0 && rest>=40){
        belief=maxBelief;
        rest=0;
      }
      else if(belief==0 && rest<40){
        rest++;
      }
    }
    
    // Saw neither a zombie, nor some panicking and not active
    else if(active==0) {
      rest++;
    }
    
    // pretty likely to change direction
    if ((int)random(2)==1) {
      
      // that line makes them turn toward the attractor
      if (attracted !=0) turnToTarget(); 
      else dir = (int)random(4)+1;
    }
  }
  
}

// Class of the corpses lying around. 
// They stay there doing nothing...
class Dead extends Being {
  
  int seeList[][]={};
  int ignoreList[] = {empty,hit};
  
  Dead(Being being){
    xpos = being.xpos;
    ypos = being.ypos;
    type = isdead;
    originalType = being.type;
    deathCause=being.deathCause;
    changed = -1;
    wld=being.wld;
  }
  
  void drawBeing(){
    
    if (lookPixel(seeList,ignoreList,xpos,ypos)==seeNothing) 
        setBeing(xpos,ypos,dead);
    if (update) update=false;
  }
  
  void move(){
    drawBeing();
  } 
  
  // Dead can't be infected nor die.
  void die(int deathCause){}
}

class Zombie extends Being {
  int zombielife;
  int seeList[][] = {  {wall,seeWall},
                       {sand,seeWall},
                       {concrete,seeConcrete},
                       {panicHuman, seeHuman},
                       {human, seeHuman},
                       {shootingSoldier, seeHuman},
                       {soldier, seeHuman},
                       {emptySoldier,seeHuman}};
  int ignoreList[] = {empty,dead,hit};
  
  Zombie(){
  }
  
  Zombie(World _wld){
    super(_wld);
  }
  
  Zombie(Being being,int _generation){
    xpos=being.xpos;
    ypos=being.ypos;
    dir=being.dir;
    type=iszombie;
    originalType=being.type;
    active = 0;
    zombielife=(int)random(200)+800;
    generation= _generation+1;
    changed=-1;
    wld=being.wld;
  }
  
  void drawBeing(){
    if (active > 0) setBeing(xpos, ypos, activeZombie);
    else setBeing(xpos, ypos, zombie);
  }
  
  void attack(Being being){
    being.infect(generation,iszombie);
  }
  
   void move(){
     int target; // store data from look()
   //Zombies move once every 4 ticks
    
     int r = (int)random(3); 
     if (r==1) {
        setBeing(xpos, ypos, empty);
        
        // if sees nothing in direction, moves
        target=look(seeList,ignoreList,dir,1);   
        if (target==seeNothing){
          xpos += directionX(dir);
          ypos += directionY(dir);
        }
        
        // otherwise turns
        else {
          if (target!=seeHuman) dir = (int)random(4)+1;
        }
        
        // draws the zombie at its new position
        drawBeing();
      }
  
      // now, checks what can be seen
      target = look(seeList,ignoreList,dir,10);
      
      // if sees human, activates
      if (target==seeHuman) active = 10; 
      
      // if sees a wall, might destroy it
      else if (target==seeWall)  { 
        if((int)random(4)==1){
          setBeing(xpos+directionX(dir),ypos+directionY(dir),empty); 
        }
      }
      else if (target==seeConcrete) {
        if((int)random(16)==1){
          setBeing(xpos+directionX(dir),ypos+directionY(dir),empty); 
        }
      }
      
      // might turn if is not active
      if (attracted !=0) turnToTarget(); 
      else if (active==0){ 
        if((int)random(10)==1){
          if((int)random(2)==0) dir = dir+1;
          else dir = dir-1;
          if(dir==5) dir=1;
          if(dir==0) dir=4;
        }
      }
      if (active>0) {active--;}

      
      // look for victims
      int victim = look(seeList,ignoreList,dir,1);
      if (victim == seeHuman){
        int ix = xpos+directionX(dir);
        int iy = ypos+directionY(dir);
        for(int i=0; i<num; i++) {
          if (ix==wld.beings[i].xpos && iy==wld.beings[i].ypos){
            attack(wld.beings[i]);
            break;
          }
        } 
      }
      
      
      // Zombies too can die...
      zombielife--;
      if(zombielife<=0) die(deathAge);
  }
}

class Soldier extends Human{
  int ammoInit = 8;
  int ammo;
  
  int seeList[][] = {  {emptySoldier,seeSoldier},
                       {zombie,seeZombie},
                       {activeZombie,seeZombie},
                       {weakenedZombie,seeZombie},
                       {activeWeakZombie,seeZombie}};
  
  Soldier(int x, int y,World _wld){
    super(_wld);
    xpos=x;
    ypos=y;
    active=0;
    ammo = ammoInit;
    type = issoldier;
    originalType = issoldier;
    changed=-1;
  }
  
  Soldier(Being being){
    xpos=being.xpos;
    ypos=being.ypos;
    ammo = ammoInit;
    type = issoldier;
    originalType=being.type;
    active=0;
    changed=-1;
    wld=being.wld;
  }
  
  void equip(){
    ammo = ammoInit;
    update=true;
  }
  
  void drawBeing(){
    if (ammo<=ammoInit/2) setBeing(xpos, ypos, emptySoldier);
    else if (active > 0) setBeing(xpos, ypos, shootingSoldier);
    else setBeing(xpos, ypos, soldier);
    if (update) update=false;
  }
  
  void move(){
    int dirBack;
    
    int r = (int)random(3); //being move once every 4 ticks, except panic who run every
    if (active>0 || r==1){ // if panicHuman or just moves by one
      setBeing(xpos, ypos, empty);
      
      // If just shot moves back
      if (active>0){
          dirBack=dir+2;
          if (dirBack>4) dirBack -=4;
          if (look(seeList,ignoreList,dirBack,1)==seeNothing){
            xpos += directionX(dirBack);
            ypos += directionY(dirBack);
          }
      }
      else if (look(seeList,ignoreList,dir,1)==seeNothing) {
        xpos += directionX(dir);
        ypos += directionY(dir);
      }
      
      // otherwise turns
      else dir = (int)random(4)+1; 
      drawBeing();
      if (active>0) {active--;}
    }
    
    int target = look(seeList,ignoreList,dir,10);

    // Saw a zombie !! Shoots him
    // Not efficient at all (CPU)!! 
    if (target==seeZombie){      
      for (int i=0;i<num;i++){
        int x=xpos;
        int y=ypos;
        for (int j=0;j<10;j++){
          x += directionX(dir);
          y += directionY(dir);
          if (wld.beings[i] instanceof Zombie && wld.beings[i].xpos==x 
              && wld.beings[i].ypos==y){
            if (ammo>0) {
              wld.beings[i].die(weaponTroopers);
              ammo --;
            }
          }
        }
      }
      active=5;
    }
    
    // Sees if there is there is soldier around and shares ammo 
    for (int i=0;i<4;i++){
      if (look(seeList,ignoreList,i,1)==seeSoldier){
        int ix = xpos+directionX(i);
        int iy = ypos+directionY(i);
        for(int j=0; j<num; j++) {
          if (wld.beings[j] instanceof Soldier &&
              ix==wld.beings[j].xpos && iy==wld.beings[j].ypos){
            Soldier soldier = (Soldier) wld.beings[j];
            int ammoDiff = ammo-soldier.ammo;
            if (ammoDiff>1){
              soldier.ammo+=ammoDiff/2;
              ammo-=ammoDiff/2;
            }
            break;
          }
        }        
      }
    }  
    
    // pretty likely to change direction (same as human)
    if ((int)random(2)==1) {
      if (attracted !=0) turnToTarget(); 
      else dir = (int)random(4)+1;
    }
  }
}

// Zombie that gets weaker every new generation. Will also attack near active zombies.
class WeakenedZombie extends Zombie{
  int seeList[][] = {  {wall,seeWall},
                       {sand,seeWall},
                       {concrete,seeConcrete},
                       {panicHuman, seeHuman},
                       {human, seeHuman},
                       {zombie, seeHuman},
                       {activeZombie, seeHuman},
                       {shootingSoldier, seeHuman},
                       {soldier, seeHuman},
                       {emptySoldier, seeHuman}};
  
  WeakenedZombie(Being being,int _generation){
    xpos=being.xpos;
    ypos=being.ypos;
    dir=being.dir;
    type=isweakenedZombie;
    originalType=being.type;
    active = 0;
    generation= _generation+1;
    zombielife=(int)random(50)+(150-generation*30);
    changed=-1;
    wld=being.wld;
  }
  
  void attack(Being being){
    being.infect(generation,isweakenedZombie);
  }
  
  // Same color when attack, but slightly different when normal
  void drawBeing(){
    if (active > 0) setBeing(xpos, ypos, activeWeakZombie);
    else setBeing(xpos, ypos, weakenedZombie);
    if (update) update=false;
  }
  
  int look(int _seeList[][],int _ignoreList[],int d,int dist){
    return super.look(seeList,ignoreList,d,dist);
  }
}

class MadZombie extends Zombie{
 
  int seeList[][] = {  {wall,seeWall},
                       {sand,seeWall},
                       {concrete,seeConcrete},
                       {zombie, seeHuman},
                       {activeZombie, seeHuman},
                       {weakenedZombie, seeHuman},
                       {activeWeakZombie,seeHuman}};
  
  MadZombie(Being being,int _generation){
    xpos=being.xpos;
    ypos=being.ypos;
    dir=being.dir;
    type=ismadZombie;
    originalType=being.type;
    active = 0;
    generation= _generation+1;
    zombielife=(int)random(50)+(120);
    changed=-1;
    wld=being.wld;
  }
  
  void attack(Being being){
    being.infect(generation,ismadZombie);
  }
  
  // Same color when attack, but slightly different when normal
  void drawBeing(){
    if (active > 0) {
      setBeing(xpos, ypos, activeMadZombie);
    }
    else setBeing(xpos, ypos, madZombie);
    if (update) update=false;
  }
  
  // Rather awkward way of doing, but otherwise, it is the
  // seeList defined in class Zombie that is being used.
  int look(int _seeList[][],int _ignoreList[],int d,int dist){
    return super.look(seeList,ignoreList,d,dist);
  }
}



