// This will dispay every information in the start screen, except the buttons 
// buttons will be (handled in GameSequence)
class StartScreen{

  Menu menu;
  HoverInfo hoverInfo;
  
  StartScreen(){
   
    if (gameSequence.previousStartMenu == menuAction) menu = new MenuAction();
    else if(gameSequence.previousStartMenu == menuStrategy) menu = new MenuStrategy();
    else menu = new MenuIntro();
    
    int fieldHeight=(hoverTextSize+hoverTextInterline)*3+hoverHeightMargin*2;
    hoverInfo = new HoverInfo(0,height-fieldHeight,width,fieldHeight,hoverWidthMargin,hoverHeightMargin);
  }
  
  void display(){
    background(0);
    textAlign(CENTER);
    textFont(fTitle,menuTitleSize);
    fill(colorIntroTitle);
    text("Infection control",menuTitleBorder,menuTitleBorder,width-menuTitleBorder*2,menuTitleBorder*1.5);
  
    // Check if the mouse is overing a button, and displays corresponding text
    hoverInfo.display(menu);
  }      
}

// This class creates the general menu on the introduction screen
class MenuIntro extends Menu{

  void createMenu(){
    int n = 0;
    int x = width/2-menuButtonWidth/2;
    int y = (int) (menuTitleBorder*2+ menuTitleBorder*1.5);
    int h = menuButtonHeight+1;
    
    cp5.addButton("Menu_Action")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Action)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Action",desc_Menu_Action));
       
    n+=1; 
    cp5.addButton("Menu_Strategy")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Strategy)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Strategy",desc_Menu_Strategy));
       
    n+=1; 
    cp5.addButton("Menu_Options")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Options)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Options",desc_Menu_Options)); 
  }

  int itemLength(){
    return buttonInfo.size();
  }

  void eraseMenu(){
    for (int i=0; i<itemLength();i++) {
      ButtonInfo bInfo = (ButtonInfo) buttonInfo.get(i);
      // Added condition bellow, because in mutliList, many buttons are erased automatically
      // So trying to erase them again causes errors.
      // Could be improved If I knew the type returned by cp5.controller();
      if (cp5.controller(bInfo.name)!=null) cp5.controller(bInfo.name).remove();
    }
  }
  
  // Finds the ButtonInfo in the arrayList which as the same name. Otherwise, returns null
  ButtonInfo findItem(String _name){
      ButtonInfo bInfo = null;
      
      for (int i=0; i<buttonInfo.size(); i++){
        bInfo = (ButtonInfo) buttonInfo.get(i);
        if (bInfo.name.equals(_name)) {
          return bInfo;
        }
      }
      return null;
  }
}

// Creates the menu related to the actions.
class MenuAction extends Menu{
                     
  void createMenu(){
    
    int n = 0;
    int x = width/2-menuButtonWidth/2;
    int y = (int) (menuTitleBorder*2+menuTitleBorder*1.5);
    int h = menuButtonHeight+1;
    
    // Iniates the customList the way we want (different than strategy game)
    if (gameSequence.previousStartMenu != menuAction){
      CustomList wList = (CustomList) world.weaponStock.weaponsList.get(1);
      wList.setSize(2);
    }
     
    // Adds the buttons under each other
    cp5.addButton("Menu_Action_Start")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Action_Start)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Action_Start",desc_Menu_Action_Start));
    
    n+=1;  
    n+=1;
    MultiList l = cp5.addMultiList("Menu_Action_Mission",x,y+n*h,menuButtonWidth,menuButtonHeight);
    buttonInfo.add(new ButtonInfo("Menu_Mission",desc_Menu_Mission));
    customizeMission(l,s_Menu_Mission,desc_Menu_Mission);
    
    n+=1;
    l = cp5.addMultiList("Menu_Action_Left",x,y+n*h,menuButtonWidth,menuButtonHeight);
    buttonInfo.add(new ButtonInfo("Menu_Action_Left",desc_Menu_Action_Left));
    customize(l,s_Menu_Action_Left,desc_Menu_Action_Left);
      
    n+=1;
    l = cp5.addMultiList("Menu_Action_Right",x,y+n*h,menuButtonWidth,menuButtonHeight);
    buttonInfo.add(new ButtonInfo("Menu_Action_Right",desc_Menu_Action_Right));
    customize(l,s_Menu_Action_Right,desc_Menu_Action_Right);
    
    n+=1;
    cp5.addToggle("Menu_Action_Ammo")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Action_Ammo_Unlimited)
       .getCaptionLabel().align(ControlP5.LEFT, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Action_Ammo",desc_Menu_Action_Ammo));
    
    int temp = world.weaponStock.ammoInit;
    n+=1;
    cp5.addSlider("Menu_AmmoInit")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setDecimalPrecision(0)
       .setRange(0,6)
       .setNumberOfTickMarks(7)
       .showTickMarks(false)
       .setValue(temp)
       .setCaptionLabel(s_Menu_AmmoInit)
       .getCaptionLabel().align(ControlP5.LEFT_OUTSIDE, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_AmmoInit",desc_Menu_AmmoInit,desc_Menu_Action_AmmoOff));
    
    temp = world.weaponStock.restockRate;
    n+=1;
    cp5.addSlider("Menu_AmmoRestock")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setDecimalPrecision(0)
       .setRange(0,world.weaponStock.listRestock.length-1)
       .setNumberOfTickMarks(world.weaponStock.listRestock.length)
       .showTickMarks(false)
       .setValue(temp)
       .setCaptionLabel(s_Menu_AmmoRestock)
       .getCaptionLabel().align(ControlP5.LEFT_OUTSIDE, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_AmmoRestock",desc_Menu_AmmoRestock,desc_Menu_Action_AmmoOff));
    
    temp = gameSequence.speed; // for weird reason, action is triggered as a parallel process, so need to store data temporarilly
    n+=1;
    n+=1;
    cp5.addSlider("Menu_Action_Speed")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setDecimalPrecision(0)
       .setRange(0,gameSequence.listSpeed.length-1)
       .setNumberOfTickMarks(gameSequence.listSpeed.length)
       .showTickMarks(false)
       .setValue(temp)
       .setCaptionLabel(s_Menu_Action_Speed)
       .getCaptionLabel().align(ControlP5.LEFT_OUTSIDE, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Action_Speed",desc_Menu_Action_Speed));
    
    n+=1;
    n+=1;
    cp5.addButton("Menu_Action_Default")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Action_Default)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Action_Default",desc_Menu_Action_Default));
    
    n+=1;
    cp5.addButton("Menu_Action_Back")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Action_Back)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Action_Back",desc_Menu_Action_Back));
    
    if (gameSequence.previousStartMenu == menuAction) previousValues();
    else defaultValues();
  }
  
  // Fills the multilist with the name of every weapons contained in the last list of weaponStock
  // Counts the number of buttons created.
  void customize(MultiList l,String name,String description){
    
    int buttonNumber=0;
    
    l.closeDelay=5; // delay after which must close the list (in ms ?) when mouse stopped overing
    
    MultiListButton b;
    b = l.add(name,-1);
    buttonInfo.add(new ButtonInfo(name,description));
    
    WeaponsList wList = (WeaponsList) world.weaponStock.weaponsList.get(0);
    wList.menuListWeapons(name,b,buttonInfo,0);
  }
  
  void customizeMission(MultiList l,String name,String description){
    
    int buttonNumber=0;
    
    l.closeDelay=5; // delay after which must close the list (in ms ?) when mouse stopped overing
    
    MultiListButton b;
    b = l.add(name,-1);
    buttonInfo.add(new ButtonInfo(name,description));
    
    for (int i=0; i<mission.missionDefinitions.size();i++){
      // Button for the name of the list
      MissionDefinition mDef = (MissionDefinition) mission.missionDefinitions.get(i);
      MultiListButton c = b.add(name+" "+i,i);
      buttonInfo.add(new ButtonInfo(name+" "+i,mDef.description));
      c.setLabel(mDef.name);
      c.setWidth(int (menuButtonWidth*1.3));
    }
  }
  
  // Updates the visual aspect of the weapons in multilists according to status (selected, unavailable, normal) 
  // wNumber : of weapons in the multilist
  // wListCheck : list of weapons in stock
  // wListStock : list of weapons selected (here left, and right click
  // position : ref of weapon in wList
  void updateWeaponButtons(WeaponsList wListCheck,WeaponsList wListStock){
    String name;
    ButtonInfo bInfo;
    int position;
    WeaponManager wManager = new WeaponManager();
    
    for (position=0; position<wListStock.length();position++){
    
      if (position == 0) name = s_Menu_Action_Left;
      else if (position == 1) name = s_Menu_Action_Right;
      else return;
      
      for (int i = 0; i<wListCheck.length() ; i++){
         if (cp5.controller(name+" "+i)!=null) {
           Weapon weapon = (Weapon) wManager.loadOneWeapon(wListCheck.get(i));
           bInfo = findItem(name+" "+i);
           // if weapon has been selected, highlight it
           if (i == wListStock.get(position)) buttonStatus(name+" "+i,Button_Data_Selected);
           // if weapon needs another weapon that is not selected, set it in grey
           else if (!weapon.checkRequiredWeapon(wListStock,position)) buttonStatus(name+" "+i,Button_Data_Unavailable);
           // otherwise, regular color
           else buttonStatus(name+" "+i,Button_Data_Normal);   
         }  
      }  
    }
  }
  
  // Selects the weapons at the given position
  void selectWeapon(int value,int position){
    String name;
    ButtonInfo bInfo;
    
    if (position == 0) name = s_Menu_Action_Left;
    else if (position == 1) name = s_Menu_Action_Right;
    else return;
    bInfo = findItem(name+" "+value);
    
    if (bInfo!=null ){
      if (bInfo.data == Button_Data_Normal && value>=0){
        world.weaponStock.setCustomListValue(position,value); 
        updateWeaponButtons((WeaponsList) world.weaponStock.weaponsList.get(0),
                            (WeaponsList) world.weaponStock.weaponsList.get(1));
      }
    }
  }
  
  // Selects the Mission
  void selectMission(int value){
    String name;
    ButtonInfo bInfo;
    
    name = s_Menu_Mission;
    bInfo = findItem(name+" "+value);
    
    if (bInfo!=null ){
      if (bInfo.data == Button_Data_Normal && value>=0){
        
        updateListButtons(name,mission.missionDefinitions.size(),value);
        mission.setMission(value); 
      }
    }
  }
  
  void defaultValues(){
    selectMission(0);
    selectWeapon(weaponNuke,0);
    selectWeapon(weaponTroopers,1);
    cp5.getController("Menu_Action_Speed").setValue(defaultActionSpeed);
    gameSequence.setSpeedName("Menu_Action_Speed"); // not required : for some reason, the button will do it
    cp5.getController("Menu_AmmoRestock").setValue(defaultAmmoRestock);
    world.weaponStock.setRestockName("Menu_AmmoRestock");
    cp5.getController("Menu_AmmoInit").setValue(defaultAmmoStart);
    world.weaponStock.setAmmoInitName("Menu_AmmoInit");
    controlP5.Toggle toggle = (controlP5.Toggle) (cp5.getController("Menu_Action_Ammo"));
    toggle.setState(false);
    
  }
  
  void previousValues(){
    updateListButtons(s_Menu_Mission,mission.missionDefinitions.size(),mission.missionRef);
    updateWeaponButtons((WeaponsList) world.weaponStock.weaponsList.get(0),
                        (WeaponsList) world.weaponStock.weaponsList.get(1));
    cp5.getController("Menu_Action_Speed").setValue(gameSequence.speed);
    gameSequence.setSpeedName("Menu_Action_Speed"); // not required : for some reason, the button will do it
    cp5.getController("Menu_AmmoRestock").setValue(world.weaponStock.restockRate);
    world.weaponStock.setRestockName("Menu_AmmoRestock");
    cp5.getController("Menu_AmmoInit").setValue(world.weaponStock.ammoInit);
    world.weaponStock.setAmmoInitName("Menu_AmmoInit");
    controlP5.Toggle toggle = (controlP5.Toggle) (cp5.getController("Menu_Action_Ammo"));
    toggle.setState(!limitedAmmo);
  }
  
  void getValues(){
    gameSequence.previousStartMenu=menuAction;
    gameSequence.speed = int (cp5.getController("Menu_Action_Speed").getValue());
    controlP5.Toggle toggle = (controlP5.Toggle) (cp5.getController("Menu_Action_Ammo"));
    limitedAmmo = !toggle.getState();
 
    world.weaponStock.setRestock(int (cp5.getController("Menu_AmmoRestock").getValue()));
    world.weaponStock.setAmmo(int (cp5.getController("Menu_AmmoInit").getValue()));
  }
}

class MenuStrategy extends Menu{
                     
  void createMenu(){
    int n = 0;
    int x = width/2-menuButtonWidth/2;
    int y = (int) (menuTitleBorder*2+menuTitleBorder*1.5);
    int h = menuButtonHeight+1;
    
    if (gameSequence.previousStartMenu != menuStrategy){
      CustomList wList = (CustomList) world.weaponStock.weaponsList.get(1);
      wList.setSize(1);
    }
    
    cp5.addButton("Menu_Strategy_Start")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Strategy_Start)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Strategy_Start",desc_Menu_Strategy_Start));   
    
    n+=1;
    n+=1;
    MultiList l = cp5.addMultiList("Menu_Strategy_Mission",x,y+n*h,menuButtonWidth,menuButtonHeight);
    buttonInfo.add(new ButtonInfo("Menu_Strategy_Mission",desc_Menu_Mission));
    customizeMission(l,s_Menu_Mission,desc_Menu_Mission);
    
    n+=1;
    l = cp5.addMultiList("Menu_Strategy_Weapons",x,y+n*h,menuButtonWidth,menuButtonHeight);
    buttonInfo.add(new ButtonInfo("Menu_Strategy_Weapons",desc_Menu_Strategy_Weapons));
    customize(l,s_Menu_Strategy_Weapons,desc_Menu_Strategy_Weapons);
    
    int temp = world.weaponStock.ammoInit;
    n+=1;
    cp5.addSlider("Menu_AmmoInit")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setDecimalPrecision(0)
       .setRange(0,6)
       .setNumberOfTickMarks(7)
       .showTickMarks(false)
       .setValue(temp)
       .setCaptionLabel(s_Menu_AmmoInit)
       .getCaptionLabel().align(ControlP5.LEFT_OUTSIDE, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_AmmoInit",desc_Menu_AmmoInit,desc_Menu_Action_AmmoOff));
    
    temp = world.weaponStock.restockRate;
    n+=1;
    cp5.addSlider("Menu_AmmoRestock")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setDecimalPrecision(0)
       .setRange(0,6)
       .setNumberOfTickMarks(7)
       .showTickMarks(false)
       .setValue(temp)
       .setCaptionLabel(s_Menu_AmmoRestock)
       .getCaptionLabel().align(ControlP5.LEFT_OUTSIDE, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_AmmoRestock",desc_Menu_AmmoRestock,desc_Menu_Action_AmmoOff));
    
    temp = gameSequence.turnLengthSetting;
    n+=1;
    n+=1;
    cp5.addSlider("Menu_Strategy_TurnLength")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setDecimalPrecision(0)
       .setRange(0,gameSequence.listTurnLength.length-1)
       .setNumberOfTickMarks(gameSequence.listTurnLength.length)
       .showTickMarks(false)
       .setValue(temp)
       .setCaptionLabel(s_Menu_Strategy_TurnLength)
       .getCaptionLabel().align(ControlP5.LEFT_OUTSIDE, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Strategy_TurnLength",desc_Menu_Strategy_TurnLength));
    
    temp = gameSequence.initialTurnLengthSetting;
    n+=1;
    cp5.addSlider("Menu_Strategy_InitialTurnLength")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setDecimalPrecision(0)
       .setRange(0,gameSequence.listInitialTurnLengthRatio.length-1)
       .setNumberOfTickMarks(gameSequence.listInitialTurnLengthRatio.length)
       .showTickMarks(false)
       .setValue(temp)
       .setCaptionLabel(s_Menu_Strategy_InitialTurnLength)
       .getCaptionLabel().align(ControlP5.LEFT_OUTSIDE, ControlP5.CENTER).setPaddingX(4)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Strategy_InitialTurnLength",desc_Menu_Strategy_InitialTurnLength));
    
    n+=1;  
    n+=1;  
    cp5.addButton("Menu_Strategy_Default")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Strategy_Default)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Strategy_Default",desc_Menu_Strategy_Default));
    
    n+=1;
    cp5.addButton("Menu_Strategy_Back")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Strategy_Back)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Strategy_Back",desc_Menu_Strategy_Back));
    
    if (gameSequence.previousStartMenu == menuStrategy) previousValues();
    else defaultValues();
  }
    
  void customize(MultiList l,String name,String description){
    
    int buttonNumber=0;
    
    l.closeDelay=5; // delay after which must close the list (in ms ?) when mouse stopped overing
    
    MultiListButton b;
    b = l.add(name,-1);
    buttonInfo.add(new ButtonInfo(name,description));
    
    for (int i=0; i<world.weaponStock.weaponsList.size();i++){
      // Button for the name of the list
      WeaponsList wList = (WeaponsList) world.weaponStock.weaponsList.get(i);
      MultiListButton c = b.add(name+" "+i,i+1);
      buttonInfo.add(new ButtonInfo(name+" "+i,wList.description));
      c.setLabel(wList.name);
      c.setWidth(int (menuButtonWidth*1.3));
      
      // Add weapons connected to that list
      // weaponStock.loadWeapons(i);
      if (wList.custm) wList = (WeaponsList) world.weaponStock.weaponsList.get(0);
      wList.menuListWeapons(name+" "+i,c,buttonInfo,(i+1)*listRefMultiplier);
      
      updateWeaponsNames(name+" "+i,(WeaponsList) world.weaponStock.weaponsList.get(i));
    }
  }
  
  // Crap programming : cut and pasted from menuAction
  void customizeMission(MultiList l,String name,String description){
    
    int buttonNumber=0;
    
    l.closeDelay=5; // delay after which must close the list (in ms ?) when mouse stopped overing
    
    MultiListButton b;
    b = l.add(name,-1);
    buttonInfo.add(new ButtonInfo(name,description));
    
    for (int i=0; i<mission.missionDefinitions.size();i++){
      // Button for the name of the list
      MissionDefinition mDef = (MissionDefinition) mission.missionDefinitions.get(i);
      MultiListButton c = b.add(name+" "+i,i);
      buttonInfo.add(new ButtonInfo(name+" "+i,mDef.description));
      c.setLabel(mDef.name);
      c.setWidth(int (menuButtonWidth*1.3));
    }
  }
  
  // crap Programming. in Action Strategy
  // Selects the Mission
  void selectMission(int value){
    String name;
    ButtonInfo bInfo;
    
    name = s_Menu_Mission;
    bInfo = findItem(name+" "+value);
    
    if (bInfo!=null ){
      if (bInfo.data == Button_Data_Normal && value>=0){
        
        updateListButtons(name,mission.missionDefinitions.size(),value);
        mission.setMission(value); 
      }
    }
  }
  
  /*void updateListButtons(int listRef,String name){
    ButtonInfo bInfo;

    for (int i =0; i<world.weaponStock.weaponsList.size();i++){
      //bInfo = findItem(name+" "+i);
     if (i == listRef) buttonStatus(name+" "+i,Button_Data_Selected);
     else buttonStatus(name+" "+i,Button_Data_Normal);    
    }
  }*/
  
  void updateWeaponsNames(String name,WeaponsList wList){
    WeaponManager wManager = new WeaponManager();
    
    if (wList.custm){
      for (int i=0;i<weaponNumber;i++){
        Weapon weapon = (Weapon) wManager.loadOneWeapon(i);
        cp5.getController(name+" "+i).setLabel(weapon.name);
      }
      for (int i=0; i<wList.length();i++){
        int j=0;
        while (j!=wList.get(i) && j<weaponNumber) j++;
        if (j==wList.get(i)){ 
          Weapon weapon = (Weapon) wManager.loadOneWeapon(j);
          cp5.getController(name+" "+j).setLabel((i+1)+" "+weapon.name);
        }
      }
    }
    else {  
      for (int i=0;i<wList.length();i++){
        Weapon weapon = (Weapon) wManager.loadOneWeapon(wList.get(i));
        if (i<=8) cp5.getController(name+" "+i).setLabel((i+1)+" "+weapon.name);
        else if (i==9) cp5.getController(name+" "+i).setLabel(0+" "+weapon.name);
        else cp5.getController(name+" "+i).setLabel(weapon.name);
      }
    }
  }
  
  void updateWeaponButtons(String name, WeaponsList wList){
    ButtonInfo bInfo;
    WeaponManager wManager = new WeaponManager();
    
    if (!wList.custm){
      for (int i=0; i<wList.length(); i++){
        Weapon weapon = (Weapon) wManager.loadOneWeapon(wList.get(i));
        if (!weapon.checkRequiredWeapon(wList)) buttonStatus(name+" "+i,Button_Data_Unavailable);
        else buttonStatus(name+" "+i,Button_Data_Selected);
      }
    }
    else {
      WeaponsList wListStock = (WeaponsList) world.weaponStock.weaponsList.get(0);
      for (int i=0; i<wListStock.length(); i++){
        boolean found=false;
        for (int j=0; j<wList.length(); j++){
          //bInfo = findItem(name+" "+i); 
          if (wList.get(j) == wListStock.get(i)) {
            buttonStatus(name+" "+i,Button_Data_Selected);
            found = true;
            break;
          }
          if (!found){
            Weapon weapon = (Weapon) wManager.loadOneWeapon(wListStock.get(i));
            if (!weapon.checkRequiredWeapon(wList)) buttonStatus(name+" "+i,Button_Data_Unavailable);
            else buttonStatus(name+" "+i,Button_Data_Normal);
          }
        }
      }
      updateWeaponsNames(name,wList);
    }
  }
  
  void updateAllWeaponButton(){
    for (int i=0;i<world.weaponStock.weaponsList.size();i++){
      WeaponsList wList = (WeaponsList) world.weaponStock.weaponsList.get(i);
      updateWeaponButtons(s_Menu_Strategy_Weapons+" "+i,wList);
    }
  }
  
  void selectList(int listRef){
    String name=s_Menu_Strategy_Weapons;
    WeaponsList wList = (WeaponsList) world.weaponStock.weaponsList.get(listRef);
    if (wList.rand){
      ButtonInfo bInfo = findItem(name+" "+listRef);
      if (bInfo.data==Button_Data_Selected){
        wList.shuffle();
        updateWeaponsNames(name+" "+listRef,wList);
        updateWeaponButtons(name+" "+listRef,wList);
        world.weaponStock.loadWeapons(listRef);
        return;
      }  
    }
    updateListButtons(name,world.weaponStock.weaponsList.size(),listRef);
    updateWeaponButtons(name+" "+listRef,wList);
    world.weaponStock.loadWeapons(listRef);
  }
  
  void clickedWeapon(int itemRef,int listRef){
    String name=s_Menu_Strategy_Weapons+" "+listRef;
    ButtonInfo bInfo;
    WeaponsList wList = (WeaponsList) world.weaponStock.weaponsList.get(listRef);
    
    if (wList.custm && itemRef>=0){
      CustomList cList = (CustomList) wList;
      bInfo = findItem(name+" "+itemRef);
      WeaponsList referenceList = (WeaponsList) world.weaponStock.weaponsList.get(0);
      int weaponRef = referenceList.get(itemRef);
   
      if (bInfo!=null ){
        if (bInfo.data == Button_Data_Normal){
          cList.addWeapon(weaponRef);
          updateWeaponButtons(name,wList);
        }
        else if (bInfo.data == Button_Data_Selected){
          cList.removeWeapon(weaponRef);
          updateWeaponButtons(name,wList);
        }
      }
    }
  }
  
  // Selects the weapons at the given position
  void selectWeapon(int value,int position,int listRef){
    /*String name=s_Menu_Strategy_Weapons+" "+listRef;
    ButtonInfo bInfo;
    WeaponsList wList = (WeaponsList) weaponsStock.weaponsList.get(listRef);
    
    if (wList.custm){
      CustomList cList = (CustomList) wList;
      bInfo = findItem(name+" "+value);
    
      if (bInfo!=null ){
        if (bInfo.data == Button_Data_Normal && value>=0){
          weaponStock.setCustomListValue(position,value); 
          updateWeaponButtons(name+" "+value,(WeaponsList) weaponStock.weaponsList.get(1));
        }
      }
    }*/
  }
  
  
  
  void defaultValues(){
    selectMission(0);
    selectList(5);
    updateAllWeaponButton();
    cp5.getController("Menu_Strategy_TurnLength").setValue(defaultTurnLength);
    gameSequence.setTurnLengthName("Menu_Strategy_TurnLength");
    cp5.getController("Menu_Strategy_InitialTurnLength").setValue(defaultInitialTurnLengthRatio);
    gameSequence.setInitialTurnLengthName("Menu_Strategy_InitialTurnLength");
    cp5.getController("Menu_AmmoRestock").setValue(defaultAmmoRestock);
    world.weaponStock.setRestockName("Menu_AmmoRestock");
    cp5.getController("Menu_AmmoInit").setValue(defaultAmmoStart);
    world.weaponStock.setAmmoInitName("Menu_AmmoInit");     
  }
  
  void previousValues(){
    updateListButtons(s_Menu_Mission,mission.missionDefinitions.size(),mission.missionRef);
    selectList(world.weaponStock.listCycle);
    updateAllWeaponButton();
    cp5.getController("Menu_Strategy_TurnLength").setValue(gameSequence.turnLengthSetting);
    gameSequence.setTurnLengthName("Menu_Strategy_TurnLength");
    cp5.getController("Menu_Strategy_InitialTurnLength").setValue(gameSequence.initialTurnLengthSetting);
    gameSequence.setInitialTurnLengthName("Menu_Strategy_InitialTurnLength");
    cp5.getController("Menu_AmmoRestock").setValue(world.weaponStock.restockRate);
    world.weaponStock.setRestockName("Menu_AmmoRestock");
    cp5.getController("Menu_AmmoInit").setValue(world.weaponStock.ammoInit);
    world.weaponStock.setAmmoInitName("Menu_AmmoInit");
  }
  
  void getValues(){
    gameSequence.previousStartMenu=menuStrategy;
    gameSequence.setTurnLength(int (cp5.getController("Menu_Strategy_TurnLength").getValue()));
    gameSequence.setInitialTurnLength(int (cp5.getController("Menu_Strategy_InitialTurnLength").getValue()));
    world.weaponStock.setRestock(int (cp5.getController("Menu_AmmoRestock").getValue()));
    world.weaponStock.setAmmo(int (cp5.getController("Menu_AmmoInit").getValue()));
  }
  
}

class MenuOptions extends Menu{
  /*String item[][] = {{"Menu_Option_Default",desc_Menu_Option_Default},
                     {"Menu_Option_Back",desc_Menu_Option_Back}};*/
                     
  void createMenu(){
    int n = 0;
    int x = width/2-menuButtonWidth/2;
    int y = (int) (menuTitleBorder*2+menuTitleBorder*1.5);
    int h = menuButtonHeight+1;
    
    cp5.addButton("Menu_Option_Default")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Option_Default)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Option_Default",desc_Menu_Option_Default));
    
    n+=1;
    cp5.addButton("Menu_Option_Back")
       .setPosition(x,y+n*h)
       .setSize(menuButtonWidth,menuButtonHeight)
       .setCaptionLabel(s_Menu_Option_Back)
       ;
    buttonInfo.add(new ButtonInfo("Menu_Option_Back",desc_Menu_Option_Back));
  }
}
