void mousePressed(){ 
  int mx=mouseX;
  int my=mouseY;
  
  if (gameSequence.screenRef == screenGame ){
    if (!gameSequence.finished){
      if (gameSequence.turnBased){ // If playing a strategy game
        if (mouseButton == LEFT){
          // Checks that we are clicking inside the playing area
          if (gameSequence.freeze & gameScreen.playArea.inside(mx,my)) world.weaponStock.fire(mx,my,limitedAmmo);
          // If clicks out of the playArea, unpauses the game, so there is not need to press space
          //if (!gameScreen.playArea.inside(mx,my)) gameSequence.freeze=false;
        }
        else if (mouseButton == RIGHT) world.weaponStock.cycle();
      }
      else { // if playing an action game
        if (!gameSequence.freeze && gameScreen.playArea.inside(mx,my)){
          if (mouseButton == LEFT) world.weaponStock.fireLeft(mx,my,limitedAmmo);
          else if (mouseButton == RIGHT) world.weaponStock.fireRight(mx,my,limitedAmmo);
        }
      }
    }
    else {
      InfoPanel  panel = gameScreen.infoPanel;
      if (panel.type==infoPanelRef_TransitionWin || panel.type==infoPanelRef_TransitionLoose){
        if (panel.infoArea.checkInside(mx,my)) panel.changeInfoPanel(((InfoAreaTransition)panel.infoArea).nextType );
      }
    }
  }
}


// Gets input from the keyboard
void keyPressed() {

  if(key == ESC) key = 'm'; // Otherwise will leave when pressing esc
  if(key == 'm') {
    if ( gameSequence.screenRef == screenGame ){
      gameScreen.erase();
      gameSequence.initStartScreen();
      gameSequence.screenRef=screenStart;
    }
  } 
  if(key == '+' && num < 8000) { num += 100; key='z'; }
  if(key == '-' && num > 4000) { num -= 100; key='z'; }
  if(key == 'z' || key == 'Z'){
    gameSequence.freeze=true;
    gameSequence.initGame();
    gameSequence.screenRef=screenGame;
  }
  if(key == 't' || key == 'T') {
    if (!gameSequence.turnBased) {
      gameSequence.turnBased = true;
      limitedAmmo = true;
      gameSequence.freeze = false; // Otherwise, too easy to cheat...
    }
  }
  if(key == 'r' || key == 'R'){
    if (gameSequence.turnBased){
      gameSequence.turnBased = false;
      limitedAmmo = false;
      gameSequence.freeze = false;
    }
  } 
  if(key == ' '){
    if (gameSequence.freeze) gameSequence.freeze = false;
    else if (!gameSequence.turnBased || gameSequence.finished) gameSequence.freeze=true;
  }
  if(key == 'a' || key == 'A'){
    if (limitedAmmo) limitedAmmo = false;
    else limitedAmmo = true;
  }
  if(key == 'f' || key == 'F'){
    if (fps) fps =false;
    else fps = true;
  }
  if(key == 'b' || key == 'B') world.weaponStock.cycleBack();
  if(key == 'n' || key == 'N') world.weaponStock.cycle();
  //if(key == 'g' || key == 'G') weaponStock.cycleListBack();
  //if(key == 'h' || key == 'H') weaponStock.cycleList();
  if(key == 'd' || key == 'D') world.displayBeingData.cycleMode();
  if(key == 's' || key == 'S') world.displayBeingData.cycleSecond();
  
  if(key == 't' || key == 'T') println(gameSequence.speed);
  if (key >= '0' && key <='9') {
    int value = Integer.parseInt(str(key));
    world.weaponStock.setWeapon(value);
  };
  
}

// Intercepts clicking on the different button (some might not have been created yet)

public void Menu_Action(){
  startScreen.menu.eraseMenu();
  startScreen.menu = new MenuAction();
}

public void Menu_Strategy(){
  startScreen.menu.eraseMenu();
  startScreen.menu = new MenuStrategy();
}

public void Menu_Options(){
  startScreen.menu.eraseMenu();
  startScreen.menu = new MenuOptions();
}

public void Menu_Action_Back(){
  startScreen.menu.getValues();
  startScreen.menu.eraseMenu();
  startScreen.menu = new MenuIntro();
}

public void Menu_Action_Start(){
  startScreen.menu.getValues();
  
  gameSequence.turnBased = false;
  gameSequence.freeze = false;
  world.weaponStock.loadWeapons(1); // load the custom list for weapons
      
  startScreen.menu.eraseMenu();
  gameSequence.initGame();
  gameSequence.screenRef=screenGame;
}

public void Menu_Action_Speed(){
  gameSequence.speed = (int) cp5.controller("Menu_Action_Speed").getValue();
  gameSequence.setSpeedName("Menu_Action_Speed");
}

public void Menu_AmmoRestock(){
  world.weaponStock.setRestock((int) cp5.controller("Menu_AmmoRestock").getValue());
  world.weaponStock.setRestockName("Menu_AmmoRestock");
}

public void Menu_AmmoInit(){
  world.weaponStock.setAmmo((int) cp5.controller("Menu_AmmoInit").getValue());
  world.weaponStock.setAmmoInitName("Menu_AmmoInit");
}

public void Menu_Action_Left(ControlEvent event){
  
  MenuAction menuAction = (MenuAction) startScreen.menu;
  menuAction.selectWeapon((int)event.value(),0);
}

public void Menu_Action_Right(ControlEvent event){
  MenuAction menuAction = (MenuAction) startScreen.menu;
  menuAction.selectWeapon((int)event.value(),1);
}

public void Menu_Action_Mission(ControlEvent event){
  
  MenuAction menuAction = (MenuAction) startScreen.menu;
  menuAction.selectMission((int)event.value());
}

public void Menu_Action_Ammo(boolean unlimited){
  if (unlimited){
    cp5.getController("Menu_Action_Ammo").setCaptionLabel(s_Menu_Action_Ammo_Unlimited);
    startScreen.menu.buttonStatus("Menu_AmmoInit",Button_Data_Unavailable);
    startScreen.menu.buttonStatus("Menu_AmmoRestock",Button_Data_Unavailable);
  }
  else {
    cp5.getController("Menu_Action_Ammo").setCaptionLabel(s_Menu_Action_Ammo_Limited);
    startScreen.menu.buttonStatus("Menu_AmmoInit",Button_Data_Normal);
    startScreen.menu.buttonStatus("Menu_AmmoRestock",Button_Data_Normal);
  }
}

public void Menu_Action_Default(){
  startScreen.menu.defaultValues();
}

public void Menu_Strategy_Weapons(ControlEvent event){
  int value = (int)event.value();
  int listRef,weaponRef;
  MenuStrategy menuStrategy = (MenuStrategy) startScreen.menu;
  
  if (value>=0){
    if (value < listRefMultiplier){
      menuStrategy.selectList(value-1);
    }
    else {
      listRef=value/listRefMultiplier-1;
      weaponRef=value%listRefMultiplier;
      if (listRef>=0 && listRef<world.weaponStock.weaponsList.size()){
        WeaponsList wList = (WeaponsList) world.weaponStock.weaponsList.get(listRef);
        if (wList.custm) {
          menuStrategy.clickedWeapon(weaponRef,listRef);
        }
        menuStrategy.selectList(listRef);
      }
    }
  }
}

public void Menu_Strategy_Mission(ControlEvent event){
  
  MenuStrategy menuStrategy = (MenuStrategy) startScreen.menu;
  menuStrategy.selectMission((int)event.value());
}

public void Menu_Strategy_TurnLength(){
  gameSequence.setTurnLength(int (cp5.getController("Menu_Strategy_TurnLength").getValue()));
  gameSequence.setTurnLengthName("Menu_Strategy_TurnLength");
  gameSequence.setInitialTurnLengthName("Menu_Strategy_InitialTurnLength");
}

public void Menu_Strategy_InitialTurnLength(){
  gameSequence.setInitialTurnLength(int (cp5.getController("Menu_Strategy_InitialTurnLength").getValue()));
  gameSequence.setInitialTurnLengthName("Menu_Strategy_InitialTurnLength");
}

public void Menu_Strategy_Default(){
  startScreen.menu.defaultValues();
}

public void Menu_Strategy_Back(){
  startScreen.menu.getValues();
  startScreen.menu.eraseMenu();
  startScreen.menu = new MenuIntro();
}

public void Menu_Strategy_Start(){
  startScreen.menu.getValues();
  startScreen.menu.eraseMenu();
  
  gameSequence.turnBased = true;
  limitedAmmo = true;
  gameSequence.freeze = false;
  gameSequence.speed=defaultSpeed;
  gameSequence.setSpeedRate();
  gameSequence.initGame();
  
  gameSequence.screenRef=screenGame;
}

public void Menu_Option_Back(){
  startScreen.menu.eraseMenu();
  startScreen.menu = new MenuIntro();
}

public void Menu_PanelStrategy_NextTurn(){
  if (gameSequence.freeze) {
    gameSequence.freeze = false;
    gameScreen.textPanel.menu.buttonStatus("Menu_PanelStrategy_NextTurn",Button_Data_Unavailable);
  }
  //else if (!gameSequence.turnBased) gameSequence.freeze=true;
}

public void Menu_PanelStrategy_PreviousWeapon(){
  world.weaponStock.cycleBack();
}

public void Menu_PanelStrategy_NextWeapon(){
  world.weaponStock.cycle();
}

public void Menu_PanelAction_Pause(){
  if (gameSequence.freeze) {
    gameSequence.freeze = false;
    cp5.getController("Menu_PanelAction_Pause").setCaptionLabel(s_Menu_PanelAction_Pause);
  }
  else if (!gameSequence.turnBased) {
    gameSequence.freeze=true;
    cp5.getController("Menu_PanelAction_Pause").setCaptionLabel(s_Menu_PanelAction_Continue);
  }
}

public void Menu_PanelInfo_Stat(){
  if (gameScreen.infoPanel.type != infoPanelRef_Statistics) 
    gameScreen.infoPanel.changeInfoPanel(infoPanelRef_Statistics); 
}

public void Menu_PanelInfo_Mission(){
  if (gameScreen.infoPanel.type != infoPanelRef_Mission) {
    gameScreen.infoPanel.changeInfoPanel(infoPanelRef_Mission);
  } 
}

public void Menu_PanelInfo_Score(){
  if (gameScreen.infoPanel.type != infoPanelRef_Score) {
    gameScreen.infoPanel.changeInfoPanel(infoPanelRef_Score);
  } 
}

public void Menu_PanelFinished_BackMenu(){
  gameScreen.erase();
  gameSequence.initStartScreen();
  gameSequence.screenRef=screenStart;
}

public void Menu_PanelFinished_Restart(){
  gameSequence.freeze=true;
  gameSequence.initGame();
  gameSequence.screenRef=screenGame;
}

public void Menu_PanelFinished_KeepGoing(){
  if (gameSequence.freeze) {
    gameSequence.freeze = false;
    cp5.getController("Menu_PanelFinished_KeepGoing").setCaptionLabel(s_Menu_PanelFinished_Pause);
  }
  else {
    gameSequence.freeze=true;
    cp5.getController("Menu_PanelFinished_KeepGoing").setCaptionLabel(s_Menu_PanelFinished_KeepGoing);
  }
}
