int deathAlive = -1;
int deathAge = -2;
int weaponNuke =0;
int weaponTroopers=1;
int weaponResupply=2;
int weaponSoldierAttractor=3;
int weaponSoldierRepulsor=4;
int weaponQuickBomb=5;
int weaponBomb=6;
int weaponSlowBomb=7;
int weaponMine=8;
int weaponBigMine=9;
int weaponMineField=10;
int weaponDirt=11;
int weaponConcrete=12;
int weaponHumanAttractor=13;
int weaponHumanRepulsor=14;
int weaponZombieAttractor=15;
int weaponZombieRepulsor=16;
int weaponInoculate=17;
int weaponBioweapon=18;
int weaponHeadquarter=19;

int weaponNumber = 20; // important for random !!

int defaultAmmoRestock = 3;
int defaultAmmoStart = 2;

// Returns true if the being is in the radius of the object
boolean checkBeingInArea(Being being,int x, int y,int radius) {
  int dx=being.xpos-x;
  int dy=being.ypos-y;
  int diff=(dx*dx)+(dy*dy);
  return diff<radius*radius;
}

// Class containing a list of weapons. It does only load the reference of each weapon, 
// but not the class (thus does not know the name/ description/ caracteristics of the weapons)
// Kinf of an array with a name
class WeaponsList{
  String name;
  String description;
  int weapons[]={};
  boolean rand=false;
  boolean custm=false;
  
  WeaponsList(){}
  
  WeaponsList(String _name,String _description, int _weapons[]){
    name = _name;
    description = _description;
    weapons = _weapons;
  }
  
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }
  
  void menuListWeapons(String name, MultiListButton b, ArrayList buttonInfo,int firstValue){
    WeaponManager wManager = new WeaponManager();
    int j=0;
    
    // Prints weapons in columns of 8 (menuDisplayWeaponNumber)
    while (length()-j > menuDisplayWeaponNumber){
      // If there are more than 8 create a button "more..." to display next column
      MultiListButton c = b.add(name+"_More_"+j,-1);
      buttonInfo.add(new ButtonInfo(name+"_More_"+j,desc_Menu_Action_More));
      c.setLabel(s_Menu_Action_More);
      c.setColorBackground(color(128,0,0));
      c.setWidth(int (menuButtonWidth*1.3));
      for (int i = j; i<j+menuDisplayWeaponNumber;i++){
        Weapon weapon = (Weapon) wManager.loadOneWeapon(get(i));
        b.add(name+" "+i,i+firstValue)
          .setLabel(weapon.name)
          .setWidth(int (menuButtonWidth*1.3))
          ;
        buttonInfo.add(new ButtonInfo(name+" "+i,weapon.description(),weapon.descriptionUnavailable()));
      }
      j+=menuDisplayWeaponNumber;
      b=c;
    }
    // Displays the last column
    for (int i = j; i<length();i++){
      Weapon weapon = (Weapon) wManager.loadOneWeapon(get(i));
      b.add(name+" "+i,i+firstValue)
        .setLabel(weapon.name)
        .setWidth(int (menuButtonWidth*1.3))
        ;
      buttonInfo.add(new ButtonInfo(name+" "+i,weapon.description(),weapon.descriptionUnavailable()));
    }
  }
  
  void shuffle(){
  }
}

class CustomList extends WeaponsList {
  int weapons[] = {weaponNuke};
  
  CustomList(){
    name=s_List_Custom;
    description=desc_List_Custom;
    custm=true;
  }
  
  //set the size (n) of the costumList, and fills it with the n first weapons
  void setSize(int _size){
    weapons = new int[_size];
    for (int i = 0; i<_size;i++) weapons[i]=i;
  }
  
    
  // adds the weapon at the end of the array, if that weapon hasn't been added yet.
  boolean addWeapon(int weaponRef){
    int i;
    int _weapons[];
    boolean changed =false;
    
    // test if the weapon is already in the list
    for (i=0; i<weapons.length;i++){
      if (weapons[i]==weaponRef) break;
    }
    
    //The whole array has been scrolled down, so the weapon was not there already 
    if (i==weapons.length){
      _weapons = new int[i+1];
      int j;
      for (j=0;j<i;j++){
        _weapons[j]=weapons[j];
      }
      _weapons[j]=weaponRef;
      weapons = _weapons;
      changed = true;
    }
    return changed;
  }
  
  // Remove the weapon from the array, if that weapon can be found
  boolean removeWeapon(int weaponRef){
    int i;
    int _weapons[];
    boolean changed =false;
    
    // test if the weapon is already in the list
    for (i=0; i<weapons.length;i++){
      if (weapons[i]==weaponRef) break;
    }
    
    //The weapon has been spotted in the array (array was not fully scrolled down) 
    if (i<weapons.length){
      _weapons = new int[weapons.length-1];
      int j;
      // Add every elements befor the one to be removed
      for (j=0;j<i;j++){
        _weapons[j]=weapons[j];
      }
      
      // Add every elements after the one to be removed
      for (j=i;j<weapons.length-1;j++){
        _weapons[j]=weapons[j+1];
      }
    
      weapons = _weapons;
      changed = true;
    }
    return changed;
  }
  
  // Change the reference of the weapon at a given position in the array
  // Returns the value of the weapon that has been changed, so the button can have its color reset
  int setWeapon(int position, int weaponRef){
    int changed=-1;
    
    if (position<=weapons.length){
      changed=weapons[position];
      weapons[position]=weaponRef;
   }
    
    return changed;
  }
  
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }  
}

// Lists every weapons
class FullHolster extends WeaponsList {
  int weapons[] = new int[weaponNumber];
  
  FullHolster(){
    name = s_List_FullArsenal;
    description = desc_List_FullArsenal;
    for (int i=0; i<weaponNumber;i++) weapons[i]=i;
  }
  
  // If I don't do that, it'll read the array definer in super class
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }      
}

class BioWar extends WeaponsList {
  int weapons[]= {weaponNuke,
                  weaponHumanAttractor,
                  weaponHumanRepulsor,
                  weaponZombieAttractor,
                  weaponZombieRepulsor,
                  weaponInoculate,
                  weaponBioweapon};
  
  BioWar(){
    name = s_List_Biowar;
    description = desc_List_Biowar;
  }
  
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }      
}

class Army extends WeaponsList {
  int weapons[]= {weaponNuke,
                  weaponTroopers,
                  weaponResupply,
                  weaponSoldierAttractor,
                  weaponSoldierRepulsor,
                  weaponHeadquarter,
                  weaponHumanAttractor,
                  weaponHumanRepulsor};
  
  Army(){
    name=s_List_Army;
    description=desc_List_Army;
  }
  
  // If I don't do that, it'll read the array definer in super class
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }      
}

class Demolition extends WeaponsList {
  int weapons[]= {weaponQuickBomb,
                weaponBomb,
                weaponSlowBomb,
                weaponMine,
                weaponBigMine,
                weaponMineField,
                weaponDirt,
                weaponConcrete};
  
  Demolition(){
    name=s_List_Demolition;
    description=desc_List_Demolition;
  }
  
  // If I don't do that, it'll read the array definer in super class
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }      
}

class RandomList extends WeaponsList{
  int listSize,listFirst;
  int[] weapons;
  
  RandomList(){
    listSize=5;
    listFirst=1;
    weapons = new int[listSize];
    rand = true;
    name=s_List_Nuke4;
    description=desc_List_Nuke4; 
    weapons[0]=weaponNuke;
    shuffle();
  }
  
  void shuffle(){
    WeaponManager wManager = new WeaponManager();
    
    for (int i=1;i<listSize;i++){
      weapons[i]=-1;
    }
    
    //println(wManager.weaponNameFromRef(2));
    
    for (int i=listFirst;i<listSize;i++){
      int temp = (int) random(weaponNumber);
      boolean ok =false;
      while (!ok){
        int j=0;
        for (j=0;j<i;j++){ // test if weapon hasn't been added yet
          if (temp == weapons[j]) break;
        }
        if (j==i) { // Ok, the weapon hasn't been added yet
          Weapon weapon = (Weapon) wManager.loadOneWeapon(temp);
          if (weapon.checkRequiredWeapon(this)){
            ok=true;
            weapons[i]=temp;
          }
        }
        if (!ok) temp = (int) random(weaponNumber);
      }
    }
  }
  
  // If I don't do that, it'll read the array definer in super class
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }
}

class FullRandomList extends RandomList{
  
  
  FullRandomList(){
    listSize=6;
    listFirst=0;
    weapons=new int[listSize];
    rand = true;
    name=s_List_Random6;
    description=desc_List_Random6;
    shuffle();
    
  }
   
  // If I don't do that, it'll read the array definer in super class
  int length(){
    return weapons.length;
  }
  
  int get(int i){
    return weapons[i];
  }
}

// Class used to create weapons
class WeaponManager{
  World wld;
  
  WeaponManager(){
    wld=null;
  }
  
  WeaponManager(World _wld){
    wld=_wld;
  }
  
    // returns the name of a weapon from its reference
  String weaponNameFromRef(int weaponRef){
    Weapon weapon =loadOneWeapon(weaponRef);
    if (weapon!=null) return weapon.name;
    
    return s_Weapon_Unknown;
  }
  
  // Returns an instance of a weapon, according to the reference
  Weapon loadOneWeapon(int weaponRef){
    Weapon weapon=null;  
    if (weaponRef==weaponNuke) weapon = new Weapon(wld);
    else if (weaponRef==weaponTroopers) weapon = new Troopers(wld);
    else if (weaponRef==weaponResupply) weapon = new Resupply(wld);
    else if (weaponRef==weaponSoldierAttractor) weapon = new DropSoldierAttractor(wld);
    else if (weaponRef==weaponSoldierRepulsor) weapon = new DropSoldierRepulsor(wld);
    else if (weaponRef==weaponQuickBomb) weapon = new DropQuickBomb(wld);
    else if (weaponRef==weaponBomb) weapon = new DropDevice(wld);
    else if (weaponRef==weaponSlowBomb) weapon = new DropSlowBomb(wld);
    else if (weaponRef==weaponMine) weapon = new DropMine(wld);
    else if (weaponRef==weaponBigMine) weapon = new DropBigMine(wld);
    else if (weaponRef==weaponMineField) weapon = new DropMineField(wld);
    else if (weaponRef==weaponDirt) weapon = new Dirt(wld);
    else if (weaponRef==weaponConcrete) weapon = new Concrete(wld);
    else if (weaponRef==weaponHumanAttractor) weapon = new DropHumanAttractor(wld);
    else if (weaponRef==weaponHumanRepulsor) weapon = new DropHumanRepulsor(wld);
    else if (weaponRef==weaponZombieAttractor) weapon = new DropZombieAttractor(wld);
    else if (weaponRef==weaponZombieRepulsor) weapon = new DropZombieRepulsor(wld);
    else if (weaponRef==weaponInoculate) weapon = new Inoculate(wld);
    else if (weaponRef==weaponBioweapon) weapon = new Bioweapon(wld);
    else if (weaponRef==weaponHeadquarter) weapon = new DropSoldierHQ(wld);

    return weapon;
  }
}

// This object contains every weapons that the player can use
// It holds instance of every existing weaponsList, 
// and an instance of every weapon from the loaded weapons list
class WeaponStock{
  int ammo,ammoInit;
  int ammoRestock,restockRate;
  int ammoCycle;
  int weaponCycle;
  int listCycle;
  ArrayList weaponsList;
  ArrayList weapons; // list of Weapons
  String listName;
  int listRestock[]={0,150,60,35,15,7,3};
  String listRestockName[]={s_AmmoRestock_None,s_AmmoRestock_VerySlow,s_AmmoRestock_Slow,s_AmmoRestock_Normal,
                            s_AmmoRestock_Quick,s_AmmoRestock_VeryQuick,s_AmmoRestock_ExtremellyQuick};
  int listAmmoInit[]={0,5,10,20,50,100,500};
  World wld;
  
  
  WeaponStock(World _wld){
    ammoInit = defaultAmmoStart;
    ammo = defaultAmmoStart;
    restockRate = defaultAmmoRestock;
    setRestock(restockRate);
    weaponCycle=0;
    listCycle=0;
    loadWeaponsList();
    WeaponsList wList = (WeaponsList) weaponsList.get(listCycle);
    loadWeapons(wList);
    listName=wList.name;
    wld=_wld;
  }
  
  // reninits when startgina new game
  void reinit(){
    setAmmo(ammoInit);
    weaponCycle=0;
  }
  
  void setRestock(int restock){
    restockRate=restock;
    if (restockRate>=0 && restockRate<listRestock.length) ammoRestock = listRestock[restockRate];
    else {
      restockRate=defaultAmmoRestock;
      ammoRestock = listRestock[restockRate];
    }
  }
  
  void setRestockName(String buttonName){
    cp5.controller(buttonName).setValueLabel(listRestockName[restockRate]);
  }
  
  void setAmmo(int _ammo){
    ammoInit=_ammo;
    if (ammoInit>=0 && ammoInit<listAmmoInit.length) ammo = listAmmoInit[ammoInit];
    else {
      ammoInit=defaultAmmoStart;
      ammo = listAmmoInit[ammoInit];
    }
  }
  
  void setAmmoInitName(String buttonName){
    cp5.controller(buttonName).setValueLabel(str(ammo));
  }
  
  // Load an instance of every weapons list
  // !!Weapons lists only hold reference to existing weapons, but no instance
  private void loadWeaponsList(){
    weaponsList= new ArrayList();
    weaponsList.add(new FullHolster()); // It should be the first, to allow menu creation
    weaponsList.add(new CustomList()); // It should be the second, for "Action mode" use
    weaponsList.add(new BioWar());
    weaponsList.add(new Army());
    weaponsList.add(new Demolition());
    weaponsList.add(new RandomList());
    weaponsList.add(new FullRandomList());
  }
  
  
  // This is here that an instance of every weapon from the list is created
  private void loadWeapons(WeaponsList list){
    WeaponManager wManager = new WeaponManager(wld);
    
    weapons = new ArrayList();
    for (int i=0;i<list.length();i++){
      Weapon weapon = wManager.loadOneWeapon(list.get(i));
      if (weapon !=null) weapons.add(weapon);
    }
  }
  
  void loadWeapons(int i){
    WeaponsList wList = (WeaponsList) weaponsList.get(i);
    if (wList != null) {
      loadWeapons(wList);
      listCycle = i;
      weaponCycle = 0;
    }
  }
  
  void setWeapon(int value){
    if ((value-1)>=0 && (value-1)<weapons.size()) weaponCycle = value-1;
    else if (value==0 && weapons.size()>=9) weaponCycle = 9; 
  }
  
  void cycle(){
    weaponCycle++;
    if (weaponCycle>=weapons.size()) weaponCycle=0;
  }
  
  void cycleBack(){
    weaponCycle--;
    if (weaponCycle<0) weaponCycle=weapons.size()-1;
  }
  
  void cycleList(){
    listCycle++;
    if (listCycle>=weaponsList.size()) listCycle=0;
    //WeaponsList wList = (WeaponsList) weaponsList.get(listCycle);
    loadWeapons(listCycle);
    //weaponCycle=0;
    //loadWeapons(wList);
  }
  
  void cycleListBack(){
    listCycle--;
    if (listCycle<0) listCycle=weaponsList.size()-1;
    //WeaponsList wList = (WeaponsList) weaponsList.get(listCycle);
    loadWeapons(listCycle);
    //weaponCycle=0;
    //loadWeapons(wList);
  }
  
  int setCustomListValue(int position, int value){
    CustomList wList = (CustomList) weaponsList.get(1);
    return wList.setWeapon(position,value);
  }
  
  
  void fire(int x, int y, boolean limited){
    if (weapons.size()>0){
      Weapon weapon = (Weapon) weapons.get(weaponCycle);
      
      if (limited){
        if (ammo>=weapon.cost){
          weapon.fire(x,y);
          ammo -= weapon.cost;
        }
      }
      else weapon.fire(x,y);
    }
  }
  
  void fireLeft(int x, int y, boolean limited){
    weaponCycle=0;
    fire(x, y, limited);
  }
  
  void fireRight(int x, int y, boolean limited){
    weaponCycle=1;
    fire(x, y, limited);
  }
  
  String listName(){
    if (weaponsList.size() >0){
      WeaponsList wList = (WeaponsList) weaponsList.get(listCycle);
      return wList.name;
    }
    else return "No list";
  }
  
  String name(){
    if (weapons.size() >0){
      Weapon weapon = (Weapon) weapons.get(weaponCycle);
      return weapon.name;
    }
    else return "No weapon";
  }
  
  int cost(){
    if (weapons.size() >0){
      Weapon weapon = (Weapon) weapons.get(weaponCycle);
      return weapon.cost;
    }
    else return 0;
  }
  
  void reStock(){
    if (ammoRestock!=0){
      if (ammoCycle>=ammoRestock){
        ammo++;
        ammoCycle=0;
      }
      ammoCycle++;
    }
  }
}

class Weapon {
  int cost =1;
  String name = s_Weapon_Nuke;
  String description = desc_Weapon_Nuke;
  int radiusFix =6;
  int radiusVariable =10;
  int type=weaponNuke;
  World wld;
  
  Weapon(World _wld){
    wld=_wld;
  }
  
  int requiredWeapon[] = {};
  
  void drawEffect(int mx,int my,int radius){
    fill(empty);
    stroke(hit);
    for (int i=0;i<scale;i++){
      ellipse(mx,my,radius*2-i,radius*2-i);
    }    
  }
  
  void countData(Being being){
    if (being instanceof Human)  wld.numKilledHumans++;
    if (being instanceof Zombie) wld.numKilledZombies++;
  }
  
  void impact(Being being,int mx, int my){
     being.die(type);
  }
  
  int fire(int mx, int my){
    // nuke characteristics
    int radius=((int)random(radiusVariable)+radiusFix)*scale;
    
    drawEffect(mx,my,radius);
    
    // killing the zombies and people in the radius
    // cycles through
    for(int i=0;i<num;i++){
      if(checkBeingInArea(wld.beings[i],mx,my,radius)){
        wld.beings[i].drawBeingOutside(); // because they have been erased when the effect had been drawn
        countData(wld.beings[i]);
        impact(wld.beings[i],mx,my);
       }
    }
    return cost;
  }
  
  // Sends description of the weapon
  String description(){
    String s = description+"\nCost : "+cost;
    return s;
  }
  
  // Sends the description if that weapon can not be selected
  String descriptionUnavailable(){
    int[] _requiredWeapon = getRequiredWeapon();
    WeaponManager wManager = new WeaponManager(wld);
    
    String s = desc_Weapon_Unavailable; 
    int i=0;
    for (i=0; i< _requiredWeapon.length-2;i++) s += "\""+wManager.weaponNameFromRef(_requiredWeapon[i])+"\", ";
    if (i==_requiredWeapon.length-2) {
      s += "\""+wManager.weaponNameFromRef(_requiredWeapon[i])+"\" "+desc_Weapon_Unavailable_Or;
      i++;
    }
    if (i==_requiredWeapon.length-1) s += "\""+wManager.weaponNameFromRef(_requiredWeapon[i])+"\" "+desc_Weapon_Unavailable_End;
    

    return s;
  }
  
  // Used to have the correct table from the subclass
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
  
  // returns false if that weapon requires an other to be selected, that is not is a list
  // wList : list of weapons selected
  boolean  checkRequiredWeapon(WeaponsList wList){
    
    int[] _requiredWeapon = getRequiredWeapon();
    
    // That weapon does not need any other weapon
    if ( _requiredWeapon.length == 0) {
      return true;
    }
    
    for (int i=0; i<_requiredWeapon.length; i++){
      for (int j=0; j<wList.length();j++){
        if (_requiredWeapon[i]==wList.get(j)) return true;
      }
    }
    
    return false;
  }
  
  // returns false if that weapon requires an other to be selected, that is not is a list
  // wList : list of weapons selected
  // position : position in the list being tested, so that it is not possible to replace 
  // "soldier" with something requiring the soldier
  boolean  checkRequiredWeapon(WeaponsList wList, int position){
    //return checkRequiredWeapon(wList.getList(),position,wList.length());
    int[] _requiredWeapon = getRequiredWeapon();
    
    // That weapon does not need any other weapon
    if ( _requiredWeapon.length == 0) {
      return true;
    }
    
    for (int i=0; i<_requiredWeapon.length; i++){
      for (int j=0; j<wList.length();j++){
        if (position!=j & _requiredWeapon[i]==wList.get(j)) return true;
      }
    }
    
    return false;
  }
}


class Dirt extends Weapon {
  int requiredWeapon[] = {};
  
  Dirt(World _wld){
    super(_wld);
    cost = 1;
    radiusFix = 6;
    radiusVariable = 5;
    name = s_Weapon_DropDirt;
    description = desc_Weapon_DropDirt;
    type=weaponDirt;
  }
  
  void drawEffect(int mx,int my,int radius){
    fill(sand);
    stroke(sand);
    for (int i=0;i<scale;i++){
      ellipse(mx,my,radius*2-i,radius*2-i);
    }    
  }
  
  void impact(Being being,int mx,int my){
    if (!(being instanceof Zombie)){
      being.die(weaponDirt);
    }
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class Concrete extends Weapon {
  int requiredWeapon[] = {};
  
  Concrete(World _wld){
    super(_wld);
    cost = 2;
    radiusFix = 4;
    radiusVariable = 4;
    name = s_Weapon_PourConcrete;
    description = desc_Weapon_PourConcrete;
    type = weaponConcrete;
  }
  
  void drawEffect(int mx,int my,int radius){
    fill(concrete);
    stroke(concrete);
    for (int i=0;i<scale;i++){
      ellipse(mx,my,radius*2-i,radius*2-i);
    }    
  }
  
  void impact(Being being,int mx,int my){
    if (!(being instanceof Zombie)){
      being.die(weaponConcrete);
    }
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class Troopers extends Weapon {
  int requiredWeapon[] = {};
  
  Troopers(World _wld){
    super(_wld);
    cost = 2;
    radiusFix=8;
    radiusVariable=4;
    name = s_Weapon_Soldier;
    description = desc_Weapon_Soldier;
    type = weaponTroopers;
  }
  
  void drawEffect(int mx,int my,int radius){
  }
  void impact(Being being,int mx,int my){
    being.equip();
  }
  void countData(Being being){
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class Inoculate extends Weapon {
  int requiredWeapon[] = {};
  
  Inoculate(World _wld){
    super(_wld);
    cost =1;
    radiusFix=4;
    radiusVariable=2;
    name = s_Weapon_InoculateHumans;
    description = desc_Weapon_InoculateHumans;
    type = weaponInoculate;
  }
  void drawEffect(int mx,int my,int radius){
  }
  void impact(Being being,int mx,int my){
    if (being instanceof Human) being.infect(0,isweakenedZombie);
  }
  void countData(Being being){
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class Resupply extends Weapon {
  int requiredWeapon[] = {weaponTroopers,weaponHeadquarter};
  
  Resupply(World _wld){
    super(_wld);
    cost =1;
    radiusFix=40;
    radiusVariable=0;
    name = s_Weapon_TroopSupply;
    description = desc_Weapon_TroopSupply;
    type = weaponResupply;
  }
  void drawEffect(int mx,int my,int radius){
  }
  void impact(Being being,int mx,int my){
    if (being instanceof Soldier) being.equip();
  }
  void countData(Being being){
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class Bioweapon extends Weapon {
  int requiredWeapon[] = {};
  
  Bioweapon(World _wld){
    super(_wld);
    cost =5;
    radiusFix=4;
    radiusVariable=2;
    name = s_Weapon_Bioweapon;
    description = desc_Weapon_Bioweapon;
    type = weaponBioweapon;
  }
  void drawEffect(int mx,int my,int radius){
  }
  void impact(Being being,int mx,int my){
    if (being instanceof Zombie) being.infect(0,ismadZombie);
  }
  void countData(Being being){
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropDevice extends Weapon{
  int requiredWeapon[] = {};
  
  DropDevice(World _wld){
    super(_wld);
    cost=1;
    name= s_Weapon_Bomb;
    description = desc_Weapon_Bomb;
  }
  
  int fire(int x, int y){
    wld.devices.add(new Device(x,y,wld));
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropSlowBomb extends Weapon{
  int requiredWeapon[] = {};
  
  DropSlowBomb(World _wld){
    super(_wld);
    cost=2;
    name= s_Weapon_BigBomb;
    description = desc_Weapon_BigBomb;
  }
  
  int fire(int x, int y){
    wld.devices.add(new SlowBomb(x,y,wld));
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropQuickBomb extends Weapon{
  
  DropQuickBomb(World _wld){
    super(_wld);
    cost=1;
    name= s_Weapon_QuickBomb;
    description = desc_Weapon_QuickBomb;
  }
  
  int fire(int x, int y){
    wld.devices.add(new QuickBomb(x,y,wld));
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropMine extends Weapon{
  
  DropMine(World _wld){
    super(_wld);
    cost=1;
    name= s_Weapon_Mine;
    description= desc_Weapon_Mine;
  }
  
  int fire(int x, int y){
    wld.devices.add(new Mine(x,y,wld));
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropBigMine extends Weapon{
  
  DropBigMine(World _wld){
    super(_wld);
    cost=2;
    name= s_Weapon_BigMine;
    description= desc_Weapon_BigMine;
  }
  
  int fire(int x, int y){
    wld.devices.add(new BigMine(x,y,wld));
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropMineField extends Weapon{
  int ratio; //radius/number of mines
  
  DropMineField(World _wld){
    super(_wld);
    cost=3;
    radiusFix=20;
    radiusVariable=8;
    ratio=4;
    name= s_Weapon_Minefield;
    description= desc_Weapon_Minefield;
  }
  
  int fire(int x, int y){
    
    int radius=((int)random(radiusVariable)+radiusFix)*scale;
    for (int i=0;i<(radius/ratio);i++){
      wld.devices.add(new Mine(x+(int)random(radius)-radius/2,
                  y+(int)random(radius)-radius/2,wld));
    }
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropHumanAttractor extends Weapon {
  int strength;
  
  DropHumanAttractor(World _wld){
    super(_wld);
    cost=1;
    name= s_Weapon_MeetingPoint;
    description= desc_Weapon_MeetingPoint;
    strength=0;
  }
  
  int fire(int x, int y){
    wld.devices.add(new Pulse(x,y,strength,wld));
    strength++;
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropHumanRepulsor extends Weapon {
  int strength;
  
  DropHumanRepulsor(World _wld){
    super(_wld);
    cost=2;
    name= s_Weapon_ForbiddenArea;
    description= desc_Weapon_ForbiddenArea;
    strength=0;
  }
  
  int fire(int x, int y){
    wld.devices.add(new HumanRepulsor(x,y,strength,wld));
    strength--;
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropSoldierAttractor extends Weapon {
  int strength;
  int requiredWeapon[] = {weaponTroopers,weaponHeadquarter};
  
  DropSoldierAttractor(World _wld){
    super(_wld);
    cost=1;
    name= s_Weapon_GroupTroops;
    description= desc_Weapon_GroupTroops;
    strength=0;
  }
  
  int fire(int x, int y){
    wld.devices.add(new SoldierAttractor(x,y,strength,wld));
    strength++;
    return cost;
  }
    // Obliged to add this to have the correct array to be taken into account.
  /*boolean checkRequiredWeapon(WeaponsList wList){
    return _checkRequiredWeapon(wList,requiredWeapon);
  }
  boolean checkRequiredWeapon(WeaponsList wList, int position){
    return _checkRequiredWeapon(wList, position, requiredWeapon);
  }*/
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropSoldierHQ extends Weapon {
  int strength;
  
  DropSoldierHQ(World _wld){
    super(_wld);
    cost=5;
    name= s_Weapon_Headquarter;
    description= desc_Weapon_Headquarter;
    strength=0;
  }
  
  int fire(int x, int y){
    wld.devices.add(new SoldierHQ(x,y,strength,wld));
    strength++;
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropSoldierRepulsor extends Weapon {
  int strength;
  int requiredWeapon[] = {weaponTroopers,weaponHeadquarter};
  
  DropSoldierRepulsor(World _wld){
    super(_wld);
    cost=1;
    name= s_Weapon_Disband;
    description= desc_Weapon_Disband;
    strength=0;
  }
  
  int fire(int x, int y){
    wld.devices.add(new SoldierRepulsor(x,y,strength,wld));
    strength++;
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropZombieAttractor extends Weapon {
  int strength;
  
  DropZombieAttractor(World _wld){
    super(_wld);
    cost=2;
    name= s_Weapon_ZombieBait;
    description= desc_Weapon_ZombieBait;
    strength=0;
  }
  
  int fire(int x, int y){
    wld.devices.add(new ZombieAttractor(x,y,strength,wld));
    strength++;
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class DropZombieRepulsor extends Weapon {
  int strength;
  
  DropZombieRepulsor(World _wld){
    super(_wld);
    cost=3;
    name= s_Weapon_ZombieRepellent;
    description= desc_Weapon_ZombieRepellent;
    strength=0;
  }
  
  int fire(int x, int y){
    wld.devices.add(new ZombieRepulsor(x,y,strength,wld));
    strength--;
    return cost;
  }
  
  int[] getRequiredWeapon(){
    return requiredWeapon;
  }
}

class Device extends Weapon {
  int x,y;
  int timer=0; // number of frames (increases when paused)
  int life; // number of games frames (does not increases when paused)
  color colour,colour1,colour2;
  boolean destroyed=false;
  
  Device(World _wld){
    super(_wld);
  }
  
  Device(int _x, int _y, World _wld){
    super(_wld);
    x=_x;
    y=_y;
    radiusFix=20;
    radiusVariable=8;
    life=100; 
    colour1=color(254,0,0);
    colour2=color(255,255,0);
    type = weaponBomb;
  }
  
  // draws the device on the screen. 
  // blinks even if game paused
  void drawDevice(){
    // Chooses the color
    if (life<20 && life >=0){
      if (timer%4==0) colour=colour1;
      else colour=colour2;
    }
    else if (life<=50 && life >=0){
      if (timer%8<4) colour=colour1;
      else colour=colour2;
    }
    else if (life<=100 && life >=0){
      if (timer%16<8) colour=colour1;
      else colour=colour2;
    }
    else {
      if (timer%32<16) colour=colour1;
      else colour=colour2;
    }
    
    // Draws the device
    for (int i=0;i<scale*2;i++){
      for (int j=0;j<scale*2;j++){
        set(x+i,y+j,colour);
      }
    }
    timer++;
  }
  
  void eraseDevice(){
    for (int i=0;i<scale*2;i++){
      for (int j=0;j<scale*2;j++){
        set(x+i,y+j,empty);
      }
    }
  }
  
  // every game frame, checks what the device does
  void act(){
    if (life ==0) {
      fire(x,y);
      destroyed=true;
      eraseDevice();
    }
    else life--;
  } 
}

class SlowBomb extends Device {
  
  SlowBomb(int _x, int _y,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    radiusFix=25;
    radiusVariable=10;
    life=150; 
    colour1=color(254,0,0);
    colour2=color(255,255,0);
    type=weaponSlowBomb;
  }
}

class QuickBomb extends Device {
  
  QuickBomb(int _x, int _y,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    radiusFix=15;
    radiusVariable=7;
    life=50;
    colour1=color(254,0,0);
    colour2=color(255,255,0);
    type=weaponQuickBomb;
  }
}

class Mine extends Device {
  boolean changed = false;
  int distance,delay;
  
  Mine(World _wld){
    super(_wld);
  }
  
  Mine(int _x, int _y,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    distance=8;
    radiusFix=10;
    radiusVariable=4;
    delay =15;
    life=100; // so blinks slowly
    colour1=color(0,254,0);
    colour2=color(255,255,0);
    type=weaponMine;
  }
  
  void act(){
    if (timer%4==0 && !changed){
      for (int i=0; i<num;i++){
        if (wld.beings[i] instanceof Zombie && checkBeingInArea(wld.beings[i],x,y,distance)){
          life = delay; 
          changed=true;
        }
      }
    }
    if (changed) {
      if (life ==0) {
        eraseDevice();
        fire(x,y);
        destroyed = true;
      }
      else life --;
    }
  }
}

class BigMine extends Mine {
  
  BigMine(int _x, int _y,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    radiusFix=18;
    radiusVariable=8;
    distance=12;
    delay =25;
    life=200; // so blinks slowly
    colour1=color(0,254,0);
    colour2=color(255,255,0);
    type=weaponBigMine;
  }
}

class Pulse extends Device {
  int cycle;
  int strength;
    
  Pulse(World _wld){
    super(_wld);
  }
  
  Pulse(int _x, int _y, int _strength,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    strength=_strength;
    cycle=40+(int)random(4);
    radiusFix=20;
    radiusVariable=0;
    life=600; 
    colour1=human;
    colour2=color(0,254,0);
    type=weaponHumanAttractor;
  }
  
  void impact(Being being,int mx, int my){
    if (being instanceof Human && !(being instanceof Soldier) ){
      being.attract(mx,my,50,strength);
    }
  }
  
  void drawEffect(int mx,int my,int radius){
  }
  
  void countData(Being being){
  }
  
  void act(){
    if (life%cycle==0) {
      fire(x,y);
    }
    life--;
    if (life ==0) {
      eraseDevice();
      destroyed=true;
    }
  } 
}

class HumanRepulsor extends Pulse{
  
 
  HumanRepulsor(int _x, int _y, int _strength, World _wld){
    super(_wld);
    x=_x;
    y=_y;
    strength=_strength;
    cycle=40+(int)random(4);
    radiusFix=20;
    radiusVariable=0;
    life=400; 
    colour1=human;
    colour2=color(254,0,0);
    type=weaponHumanRepulsor;
  }
  
  void impact(Being being,int mx, int my){
    if (being instanceof Human && !(being instanceof Soldier) ){
      being.attract(mx,my,-50,strength);
    }
  }
}

class SoldierAttractor extends Pulse{
   
  SoldierAttractor(int _x, int _y, int _strength, World _wld){
    super(_wld);
    x=_x;
    y=_y;
    strength=_strength;
    cycle=100;
    radiusFix=40;
    radiusVariable=0;
    life=200; 
    colour1=soldier;
    colour2=color(0,254,0);
    type=weaponSoldierAttractor;
  }
  
  void impact(Being being,int mx, int my){
    if (being instanceof Soldier){
      being.attract(mx,my,20,strength);
    }
  }
}

class SoldierHQ extends Pulse{
  int radiusTrain = 25;
  
  SoldierHQ(int _x, int _y, int _strength,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    strength=_strength;
    cycle=200;
    radiusFix=40;
    radiusVariable=0;
    life=1000; 
    colour1=soldier;
    colour2=color(0,254,0);
    type=weaponHeadquarter;
  }
  
  void impact(Being being,int mx, int my){
      if (being instanceof Soldier){
        being.attract(mx,my,10,strength);
        being.equip();
      }
      if ((being instanceof Human) && !(being instanceof Soldier) 
          && checkBeingInArea(being,mx,my,radiusTrain)) being.equip();
  }
}

class SoldierRepulsor extends Pulse{
 
  SoldierRepulsor(int _x, int _y, int _strength,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    strength=_strength;
    cycle=100;
    radiusFix=20;
    radiusVariable=0;
    life=200; 
    colour1=soldier;
    colour2=color(254,0,0);
    type=weaponSoldierRepulsor;
  }
  
  void impact(Being being,int mx, int my){
    if (being instanceof Soldier){
      being.attract(mx,my,-30,strength);
    }
  }
}

class ZombieAttractor extends Pulse{
 
  ZombieAttractor(int _x, int _y, int _strength,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    strength=_strength;
    cycle=25+(int)random(4);
    radiusFix=20;
    radiusVariable=0;
    life=500; 
    colour1=zombie;
    colour2=color(0,254,0);
    type=weaponZombieAttractor;
  }
  
  void impact(Being being,int mx, int my){
    if (being instanceof Zombie){
      being.attract(mx,my,50,strength);
    }
  }
}

class ZombieRepulsor extends Pulse{
 
  ZombieRepulsor(int _x, int _y, int _strength,World _wld){
    super(_wld);
    x=_x;
    y=_y;
    strength=_strength;
    cycle=25+(int)random(4);
    radiusFix=20;
    radiusVariable=0;
    life=400; 
    colour1=zombie;
    colour2=color(254,0,0);
    type=weaponZombieRepulsor;
  }
  
  void impact(Being being,int mx, int my){
    if (being instanceof Zombie){
      being.attract(mx,my,-50,strength);
    }
  }
}
