// Zombie Infection Simulation
// Kevan Davis, 16/8/03

// Modified by John Gilbertson 25/09/03
// just making zombies more dangerous, edited level creation code, increased max zombies, made zombies less likely to group etc...

// Modified by Fabien Vidal 05/12/2012 v.13 (11/05/12 V.1.0)
// Heavy work on the structure. Multiple weapons, UI, missions and graph
// 
//

import controlP5.*; // Library used to add controllers (buttons, slider,...)

//boolean freeze; // pauses the simulation
int num=4000;
color human;
color panicHuman;
color zombie;
color activeZombie;
color weakenedZombie;
color activeWeakZombie;
color madZombie;
color activeMadZombie;
color dead;
color wall;
color sand;
color concrete;
color empty;
color hit;
color soldier;
color emptySoldier;
color shootingSoldier;
int clock;
int tick;
int scale=2;

String version = "1.3";

color colorWin;
color colorLoose;
color colorMisc;
color colorText;
color colorTextHighlight;
color colorDisabled;

color colorBackground1;
color colorBackground2;
color colorLine;
color colorHoverField;
color colorHoverText;
color colorIntroTitle;

int colorLoopLength =50;

int defaultTurnLength=2;
int defaultInitialTurnLengthRatio=2;
boolean limitedAmmo=true;
int targetFrameRate = 60;
int defaultSpeed=4;
int defaultActionSpeed=2;

boolean fps=false;

int ishuman=0;
int iszombie=1;
int isdead=2;
int issoldier=3;
int isweakenedZombie=4;
int ismadZombie=5;

int seeSomething=-1;
int seeNothing=0;
int seeZombie=1;
int seeHuman=2;
int seeWall=3;
int seePanicHuman=4;
int seeSoldier=5;
int seeConcrete=6;

int dataHuman=0;
int dataSoldier=1;
int dataZombie=2;
int dataDead=3;
int dataKilledHumans=4;
int dataKilledZombies=5;
int dataInoculatedHumans=6;

int gWidth,gHeight;
int playWidthMini=700;
int playHeightMini=350;
int panelHeight=30;
int infoHeight=140;
int hoverTextSize=12;
int hoverTextInterline=3;
int hoverHeightMargin=5;
int hoverWidthMargin=20;

int infoWidthPosition=76;

int textMargin=5;

int infoTitleWidth = 120;
int infoTextWidth = 400;
int infoTargetWidth = 100;
int InfoPositionWidth = 76; // In the info screen is devided in 8 positions

int menuTitleBorder=50;
int menuTitleSize=50;
int menuButtonWidth=70;
int menuButtonHeight=19;
int panelButtonWidth=40;
int panelTextWidth=150;
int costTextWidth =70;

StartScreen startScreen;
GameScreen gameScreen;
Mission mission;
GameSequence gameSequence;
World world;
Blink blink; // will be used for some text effetc.
 

DecimalFormat decimalFormat;
ControlP5 cp5;
PFont fNormal;
PFont fBold;
PFont fTitle;

// Things to move in the World class
//ArrayList datas;    // data stored for the graph

void setup() { 
  
  // defines a format to print floats (to print FPS, later)
  decimalFormat = (DecimalFormat)DecimalFormat.getInstance(Locale.FRENCH);
  decimalFormat.applyPattern("0");
 
  frameRate(targetFrameRate);
  
  size(playWidthMini,playHeightMini+panelHeight+infoHeight+hoverTextSize+hoverTextInterline+hoverHeightMargin*2);
  
  fNormal=loadFont("ArialMT-11.vlw");
  fBold=loadFont("Arial-BoldMT-14.vlw");
  fTitle=loadFont("KristenITC-Regular-19.vlw");
  
  human=color(200,0,200);
  panicHuman=color(255,120,255);
  zombie=color(0,150,0);
  activeZombie=color(0,255,0);
  weakenedZombie=color(0,200,150);
  activeWeakZombie=color(0,255,220);
  madZombie=color(200,100,0);
  activeMadZombie=color(255,200,0);
  wall=color(70,70,80);
  concrete=color(120,120,140);
  sand=color(160,120,100);
  empty=color(0,0,0);
  dead=color(128,30,30);
  hit=color(128,128,0);
  shootingSoldier=color(100,255,255);
  soldier=color(0,130,255);
  emptySoldier=color(0,50,200);
  
  colorWin=color(30,255,0);
  colorLoose=color(255,30,0);
  colorMisc=color(255,128,0);
  colorText=color(239,228,176);
  colorDisabled=color(150,150,140);
  colorTextHighlight=color(250,250,240);
  colorBackground1=color(1,21,31);
  colorBackground2=color(1,41,62);
  colorLine=color(1,10,20);
  colorHoverField=color(40,40,50);
  colorHoverText=color(255);
  colorIntroTitle=human;
   
  // This will contain the different controllers
  cp5 = new ControlP5(this);
  
  gameSequence = new GameSequence(); 
  gameSequence.initStartScreen();
} 
 

void draw() { 
  gameSequence.display();
}



