// Classes that enables to draw a graph from a list of values.
// There are 2 important class :
// Data, wich stores the data
// Graph, which displays the data

// That class stores the values
class value{
  int x;
  value(int _x){
    x = _x;
  }  
};

// gets the closest (smaller) power of 10 of a positive integer
int closestDecimal(int value){
  int i=0;
  
  while (pow(10,i)<value)i++;   
  return (int) pow(10,i-1);
}

// Class data, which stores an undetermined number of int
// It knows which is the max and minimum value
class Data{
  ArrayList values;
  int dataMax;
  int dataMin;
  color dataColor;
  String name;
  
  Data(color _dataColor,String _name){
    values = new ArrayList();
    dataMax=0; // will be changed when first data will be added
    dataMin=0; // idem
    dataColor=_dataColor;
    name=_name;
  }

  void add(int x){
    if (values.size()==0){ // when first data added
      dataMax=x;
      dataMin=x;
    }
    else {
      if (x>dataMax) dataMax=x;
      if (x<dataMin) dataMin=x;
    }
    values.add(new value(x));
  }  
  
  int get(int i){
    value x = (value) values.get(i);
    return x.x;
  }
  
  int getLast(){
    value x = (value) values.get(values.size()-1);
    return x.x;
  }
  
  int min(){
    return dataMin;
  }
  
  int max(){
    return dataMax;
  }
  
  int size(){
    return values.size();
  }
  
  /*int color(){
    return dataColor;
  }*/
  
  // randomly fills the data with values between 0 and 99
  // mostly for testing purpose
  void Random(int dataSize){
    for (int i=0;i<dataSize;i++){
      if (i==0)add((int)random(10));
      else add(get(i-1)+(int)random(10));
    }
  }
}

class Graph{
  int x,y,width,height;
  color bgColor,drColor;
  
  ArrayList datas; // passed by reference. So they are stored out of this object
  PFont f;
  
  Graph(int _x, int _y, int _width, int _height,ArrayList _datas ){
    f=fNormal;
    bgColor = color(100);
    drColor = color(0); 
    x = _x;
    y = _y;
    width = _width;
    height = _height;
    datas = _datas;
  }
  
  // sets the background color
  void bgColor(color _bgColor){
    bgColor = _bgColor;
  }
  
  // sets the color the axis will be drawn
  void drColor(color _drColor){
    drColor = _drColor;
  }
  
  //draws the graph
  void draw(){
    float step,factor,value;
    int space = 5;
    int fontSize = 10;
    int spaceLeft,spaceBottom;
    int i,yMax, xMax, yUnit, xUnit;
    int spaceLegend = 80;
    Data data;
        
    // draws the area
    rectMode(CORNER);
    noStroke();
    fill(bgColor);
    rect(x,y,width,height);
    
    if (datas!=null){
      // draws the legend
      textFont(f,fontSize);
      for (i=0;i<datas.size();i++){
        data = (Data) datas.get(i);
        fill(data.dataColor);
        textAlign(CENTER);
        String s = data.name + ": "+ data.getLast();
        text(s,x+width-spaceLegend/2,y+height/2+(i+1)*fontSize-datas.size()*fontSize/2);
      }
      
      // Room to leave left and bottom
      yMax=0;
      xMax=0;
      for (i=0;i<datas.size();i++) {
        data = (Data) datas.get(i);
        if (yMax<data.max()) yMax=data.max();
        if (xMax<data.size()) xMax=data.size();
      }
      yUnit = closestDecimal(yMax);
      String tempText = yUnit+"";
      spaceLeft=space+(int)textWidth(tempText);
      
      xUnit = closestDecimal(max(xMax,width-spaceLegend-spaceLeft));
      spaceBottom=space+fontSize;
      
      // finds how to scale the graph
      if (xMax<width-(spaceLeft+spaceLegend)){
        step = 1;
      }
      else step = (float)xMax/(width-(spaceLeft+spaceLegend));
      factor = (float)yMax/(height-(space+spaceBottom));
      
      // draws the canvas
      stroke(drColor);
      line(x+spaceLeft,y+height-spaceBottom,x+spaceLeft,y+space);
      line(x+spaceLeft,y+height-spaceBottom,x+width-spaceLegend,y+height-spaceBottom);   
      
      // draws the units on y axis
      fill(drColor);
      i=0;
      while (i<yMax){
        value = (float)i/factor;
        line(x+spaceLeft,y+height-(spaceBottom+1)-(int)value,x+spaceLeft+3,y+height-(spaceBottom+1)-(int)value);
        tempText = i+"";
        textAlign(RIGHT);
        text(tempText,x+spaceLeft-2,y+height-spaceBottom-(int)value+fontSize/2);
        i+=yUnit;
      }
   
      i=0;
      while (i<max(xMax,width-spaceLegend-spaceLeft)){ // that bit could be optimized
        value = (float)i/step;
        line(x+spaceLeft+(int)value,y+height-spaceBottom,x+spaceLeft+(int)value,y+height-spaceBottom+3);
        tempText = i+"";
        textAlign(CENTER);
        text(tempText,x+spaceLeft+(int)value,y+height-space+2);
        i+=xUnit;
      }   
          
      // plot the values
      for (i=0;i<datas.size();i++) {
        data = (Data) datas.get(i);
        float j;
        stroke(data.dataColor);
        int k=0;
        j=step*k;
        while (j<data.size()){
          value = (float)data.get((int)j)/factor;
          point(x+spaceLeft+1+k,y+height-(spaceBottom+1)-(int)value);
          k++;
          j = step*k;
        }
      }
    }
  }   
}
